﻿Imports Presentació.ServeiGR

Public Class Plat
    Public _idPlat As Long
    Public _nomCat As String
    Public _nomCas As String
    Public _nomAng As String
    Public _minPersones As Long
    Public _preu As Double
    Public _urlFoto As String
    Public _idSeccio As Long
    Public _imatge() As Byte

    Public Sub New(ByVal idPlat As Long)
        Me._idPlat = idPlat
    End Sub

    Public Sub New(ByVal idPlat As Long, _
                   ByVal nomCat As String, _
                   ByVal nomCas As String, _
                   ByVal nomAng As String, _
                   ByVal minPersones As Long, _
                   ByVal preu As Double, _
                   ByVal urlFoto As String, _
                   ByVal idSeccio As Long, _
                   Optional ByVal imatge() As Byte = Nothing)
        Me._idPlat = idPlat
        Me._nomCat = nomCat
        Me._nomCas = nomCas
        Me._nomAng = nomAng
        Me._minPersones = minPersones
        Me._preu = preu
        Me._urlFoto = urlFoto
        Me._idSeccio = idSeccio
        Me._imatge = imatge
    End Sub

    Public Function AfegirPlat() As Boolean
        '
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Return connexio.AfegirPlat(Me._nomCat, _
                                Me._nomCas, _
                                Me._nomAng, _
                                Me._minPersones, _
                                Me._preu, _
                                Me._urlFoto, _
                                Me._idSeccio, _
                                Me._imatge)
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
        ''
    End Function

    Public Function EsborrarPlat() As Boolean
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Return connexio.EsborrarPlat(Me._idPlat)
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Function

    Public Function ModificarPlat() As Boolean
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Return connexio.ModificarPlat(Me._idPlat, _
                                           Me._nomCat, _
                                           Me._nomCas, _
                                           Me._nomAng, _
                                           Me._minPersones, _
                                           Me._preu, _
                                           Me._urlFoto, _
                                           Me._idSeccio, _
                                           Me._imatge)
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try

    End Function

    Public Function EsPotEsborrarPlat() As Boolean
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Return connexio.EsPotEsborrarPlat(Me._idPlat)
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Function

End Class
