﻿Imports Microsoft.VisualBasic
Imports System.Text
Imports Presentació.ServeiGR
Imports System.Security
Imports System.Security.Cryptography

Public Class FormCambrerAlta

    Private bUsuariProposat As Boolean
    Private lIdCambrer As Long = -1
    Private mode As Long = 1 ' 0 modifica, 1 alta
    Private sNomUsuari As String
    Private oCambrer As Cambrer

    Public Sub New()
        ' Llamada necesaria para el Diseñador de Windows Forms.
        InitializeComponent()
        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        Me.Inicialitzar()
    End Sub

    Public Sub New(ByVal idPersona As Long)
        ' Constructor utilitzat per carregar les dades quan fan el doble click al llistat
        InitializeComponent()
        '
        Me.lIdCambrer = idPersona
        Me.mode = 0
        Me.bUsuariProposat = True
        Me.CarregarDadesCambrer()
    End Sub

    Private Sub FormCambrerAlta_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Me.Inicialitzar()
    End Sub

    Private Sub FormCambrerAlta_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).AltaCambrerToolStripMenuItem.Enabled = True
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Inicialitzar()
        Me.oCambrer = Nothing
    End Sub

    Private Sub btnAltaAct_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAltaAct.Click
        If Not Me.ValidarFormulari() Then
            Exit Sub
        End If
        '
        Dim Habilitat As Boolean
        Habilitat = Me.Habilitat()
        Select Case mode
            ' Modificació
            Case 0
                oCambrer._nom = Me.txtNom.Text
                oCambrer._cognom = Me.txtCognoms.Text
                oCambrer._telefon = Me.txtTelefon.Text
                oCambrer._correE = Me.txtCorreuE.Text
                oCambrer._usuari = Me.FromatejaNomUsuari(Me.txtUsuari.Text)
                oCambrer._contrasenya = If(Me.txtContrasenya.Text <> "", Me.HashString(Me.txtContrasenya.Text), "")
                oCambrer._habilitat = Habilitat
                If Me.sNomUsuari <> Me.txtUsuari.Text Then
                    If oCambrer.UsuariRepetit() Then
                        ' Validem que l'usuari es pugui agafar
                        MsgBox("Aquest usuari no es pot agafar; ja és a la base de dades")
                        'oCambrer = Nothing
                        Exit Sub
                    End If
                End If
                If oCambrer.ModificarCambrer() Then
                    MsgBox("Cambrer modificat correctament")
                End If
                ' Alta
            Case 1
                Dim cambrer As New Cambrer(-1, _
                                           Me.txtNom.Text, _
                                           Me.txtCognoms.Text, _
                                           Me.txtTelefon.Text, _
                                           Me.txtCorreuE.Text, _
                                           Me.FromatejaNomUsuari(Me.txtUsuari.Text), _
                                           Me.HashString(Me.txtContrasenya.Text), _
                                           Habilitat)
                If cambrer.UsuariRepetit() Then
                    ' Validem que l'usuari es pugui agafar
                    MsgBox("Aquest usuari no es pot agafar; ja és a la base de dades")
                    cambrer = Nothing
                    Exit Sub
                End If
                If cambrer.AfegirCambrer() Then
                    MsgBox("Cambrer donat d'alta correctament")
                End If
                Me.NetejarFormulari()
        End Select
        '
    End Sub

    Private Sub btnEsborrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEsborrar.Click
        ' Mirar que l'objecte no estigui a null i esborrar-lo
        If Not oCambrer Is Nothing Then
            ' Mirem si es pot esborrar
            If Not oCambrer.EsPotEsborrarCambrer() Then
                MsgBox("Hi ha comandes d'aquest cambrer i no es pot eliminar." & vbCrLf & "Sempre el pots deshabilitar.")
                Exit Sub
            End If
            '
            Dim iResult As Integer
            iResult = MsgBox("S'eliminarà un cambrer, estàs segur?", MsgBoxStyle.YesNo)
            If iResult = 6 Then
                If oCambrer.EsborrarCambrer() Then
                    MsgBox("Cambrer esborrat")
                End If
                oCambrer = Nothing
                Me.Inicialitzar()
            End If
        Else
            MsgBox("Falta escollir cambrer")
        End If

    End Sub

#Region "Funcions"

    Private Sub Inicialitzar()
        Me.NetejarFormulari()
        Me.btnAltaAct.Text = "Alta"
        Me.bUsuariProposat = False
    End Sub

    Private Sub NetejarFormulari()
        Me.txtNom.Text = ""
        Me.txtCognoms.Text = ""
        Me.txtTelefon.Text = ""
        Me.txtCorreuE.Text = ""
        Me.txtUsuari.Text = ""
        Me.txtContrasenya.Text = ""
        Me.rbtSi.Checked = True
        Me.rbtNo.Checked = False
        Me.bUsuariProposat = False
        Me.lIdCambrer = -1
        Me.mode = 1
    End Sub

    Private Function ValidarFormulari() As Boolean
        ValidarFormulari = True
        Dim sErrors As String
        '
        sErrors = "Els següents camps són obligatoris:" & vbCr
        '
        ' Validar que nom, cognom, usuari i contrasenya siguin plens
        '
        If Me.txtNom.Text = "" Then
            sErrors = sErrors & "Nom" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtCognoms.Text = "" Then
            sErrors = sErrors & "Cognom/s" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtUsuari.Text = "" Then
            sErrors = sErrors & "Usuari" & vbCr
            ValidarFormulari = False
        Else
            ' Mirem si conté espais; no en pot tenir
            If Trim(Me.txtUsuari.Text.Replace(" ", "")).Length <> Me.txtUsuari.Text.Length Then
                sErrors = sErrors & "El nom d'usuari no pot contenir espais" & vbCr
                ValidarFormulari = False
            End If
        End If
        ' La contrasenya, només la validem si està en mode d'afegir
        If Me.mode = 1 Then
            If Me.txtContrasenya.Text = "" Then
                sErrors = sErrors & "Contrasenya" & vbCr
                ValidarFormulari = False
            End If
        End If
        '
        If ValidarFormulari Then
            sErrors = ""
        End If
        ' Validem que el correu electrònic sigui correu electrònic
        If Me.txtCorreuE.Text <> "" Then
            If Not Me.esCorreu(Me.txtCorreuE.Text) Then
                sErrors = sErrors & "El correu electrònic és incorrecte" & vbCr
                ValidarFormulari = False
            End If
        End If
        '
        If Not ValidarFormulari Then
            MsgBox(sErrors)
        End If
    End Function

    Private Function Habilitat() As Boolean
        ' Mirem quin dels radios està marcat
        If Me.rbtSi.Checked Then
            Habilitat = True
        ElseIf Me.rbtNo.Checked Then
            Habilitat = False
        End If
    End Function

    Private Sub proposaUsuari()
        If Me.bUsuariProposat = True Then
            Exit Sub
        End If
        If Me.txtNom.Text = "" Or Me.txtCognoms.Text = "" Then
            Exit Sub
        End If
        ' Funció que proposa un usuari
        Dim usuari As String
        Dim nom As String
        Dim cognom As String
        '
        nom = Me.txtNom.Text
        cognom = Me.txtCognoms.Text
        ' Usuari: cognom + primera lletra nom
        usuari = Trim(cognom).Replace(" ", "") & Trim(Microsoft.VisualBasic.Left(nom, 1)).Replace(" ", "")
        '
        Me.txtUsuari.Text = Me.FromatejaNomUsuari(usuari)
        '
        Me.bUsuariProposat = True
        '
    End Sub

    Private Sub txtNom_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtNom.LostFocus
        Me.proposaUsuari()
    End Sub

    Private Sub txtCognoms_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtCognoms.LostFocus
        Me.proposaUsuari()
    End Sub

    Private Function esCorreu(ByVal correu As String)
        Dim sCorreu As String
        Dim rgx As New RegularExpressions.Regex("\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*")
        sCorreu = correu
        If rgx.IsMatch(sCorreu) Then
            esCorreu = True
        Else
            esCorreu = False
        End If
    End Function

    Private Sub CarregarDadesCambrer()
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Dim cambrer = connexio.ConsultarCambrer(Me.lIdCambrer)
            ' Treballem amb l'objecte
            oCambrer = New Cambrer(Me.lIdCambrer, _
                                   cambrer.nom, _
                                   cambrer.cognom, _
                                   cambrer.telefon, _
                                   cambrer.correuElectronic, _
                                   cambrer.usuari, _
                                   cambrer.contrasenya, _
                                   cambrer.habilitat)
            ' Carrega les dades
            Me.txtNom.Text = oCambrer._nom
            Me.txtCognoms.Text = oCambrer._cognom
            Me.txtTelefon.Text = oCambrer._telefon
            Me.txtCorreuE.Text = oCambrer._correE
            Me.txtUsuari.Text = oCambrer._usuari
            Me.sNomUsuari = oCambrer._usuari
            ' La contrasenya, no la recuperem
            'Me.txtContrasenya.Text = oCambrer._contrasenya
            ' Habilitat o no
            If oCambrer._habilitat Then
                Me.rbtSi.Checked = True
            Else
                Me.rbtNo.Checked = True
            End If
            ' Posem el botó a actualitzar
            Me.btnAltaAct.Text = "Actualitzar registre"
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.close()
        End Try
    End Sub

    Public Function HashString(ByVal str As String) As String
        Dim sha1 As SHA1 = SHA1Managed.Create
        Dim encoding As ASCIIEncoding = New ASCIIEncoding
        Dim stream() As Byte = Nothing
        Dim sb As StringBuilder = New StringBuilder
        stream = sha1.ComputeHash(encoding.GetBytes(str))
        Dim i As Integer = 0
        Do While (i < stream.Length)
            sb.AppendFormat("{0:x2}", stream(i))
            i = (i + 1)
        Loop
        Return sb.ToString
    End Function

    Private Function FromatejaNomUsuari(ByVal sUsuari) As String
        FromatejaNomUsuari = Me.TreureAccents(LCase(sUsuari))
    End Function

    Private Function TreureAccents(ByVal sUsuari As String) As String
        If sUsuari <> "" Then
            sUsuari = Replace(sUsuari, "¡", "", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "¿", "", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "'", "", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "á", "a", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "é", "e", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "í", "i", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ó", "o", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ú", "u", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ñ", "n", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ç", "c", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "Á", "A", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "É", "E", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Í", "I", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ó", "O", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ú", "U", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ñ", "N", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ç", "C", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "à", "a", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "è", "e", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ì", "i", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ò", "o", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ù", "u", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "À", "A", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "È", "E", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ì", "I", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ò", "O", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ù", "U", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "ä", "a", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ë", "e", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ï", "i", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ö", "o", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ü", "u", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "Ä", "A", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ë", "E", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ï", "I", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ö", "O", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ü", "U", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "â", "a", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ê", "e", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "î", "i", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "ô", "o", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "û", "u", 1, Len(sUsuari), 1)

            sUsuari = Replace(sUsuari, "Â", "A", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ê", "E", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Î", "I", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Ô", "O", 1, Len(sUsuari), 1)
            sUsuari = Replace(sUsuari, "Û", "U", 1, Len(sUsuari), 1)
        Else
            sUsuari = ""
        End If
        TreureAccents = sUsuari
    End Function

    Private Sub txtUsuari_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtUsuari.LostFocus
        Me.txtUsuari.Text = Me.FromatejaNomUsuari(Me.txtUsuari.Text).Replace(" ", "")
    End Sub

#End Region
End Class
