﻿Imports Microsoft.VisualBasic
Imports System.Text
Imports Presentació.ServeiGR
Imports System.Security
Imports System.Security.Cryptography
Imports System.Net.Mail
Imports System.Net
Imports System.Net.Mime
Imports System.Text.RegularExpressions

Public Class FormConfiguracio

    Private oConfiguracio As Configuracio

    Public Sub New()
        ' Llamada necesaria para el Diseñador de Windows Forms.
        InitializeComponent()
        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        Me.Inicialitzar()
    End Sub

    Private Sub FormCambrerAlta_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Me.Inicialitzar()
    End Sub

    Private Sub FormConfiguracio_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).ConfiguracióToolStripMenuItem.Enabled = True
    End Sub


    Private Sub btnAltaAct_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAltaAct.Click
        If Not Me.ValidarFormulari() Then
            Exit Sub
        End If
        '
        ' Inserim/actualitzem el registre
        Me.oConfiguracio = New Configuracio(-1, _
                                            Me.txtFromAdreca.Text, _
                                            Me.txtFromNom.Text, _
                                            Me.txtSignatura.Text, _
                                            Me.txtServer.Text, _
                                            Me.txtUsuari.Text, _
                                            Me.txtContrasenya.Text, _
                                            Me.txtCorreuE.Text, _
                                            CType(Me.txtPort.Text, Integer))
        If Me.oConfiguracio.AfegirConfiguracio() Then
            MsgBox("Configuració guardada")
        End If
        '
    End Sub

#Region "Funcions"

    Private Sub Inicialitzar()
        Me.NetejarFormulari()
        Me.CarregarConfiguracio()
    End Sub

    Private Sub NetejarFormulari()
        Me.txtFromAdreca.Text = ""
        Me.txtFromNom.Text = ""
        Me.txtSignatura.Text = ""
        Me.txtCorreuE.Text = ""
        Me.txtUsuari.Text = ""
        Me.txtContrasenya.Text = ""
        Me.txtPort.Text = ""
    End Sub

    Private Function ValidarFormulari() As Boolean
        ValidarFormulari = True
        Dim sErrors As String
        '
        sErrors = "Hi ha els següents errors:" & vbCr
        '
        ' Validació que no hi hagi camps buits
        ' Validació dels formats correus
        ' Validació que el port sigui numèric
        If Me.txtFromAdreca.Text = "" Then
            sErrors = sErrors & "L'adreça del remitent és obligatòria" & vbCr
            ValidarFormulari = False
        Else
            ' Comprovem que sigui en el format correcte
            If Not Me.esCorreu(Me.txtFromAdreca.Text) Then
                sErrors = sErrors & "L'adreça del remitent no té el format correcte" & vbCr
                ValidarFormulari = False
            End If
        End If
        If Me.txtFromNom.Text = "" Then
            sErrors = sErrors & "El nom del remitent és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtSignatura.Text = "" Then
            sErrors = sErrors & "La signatura és obligatòria" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtUsuari.Text = "" Then
            sErrors = sErrors & "L'usuari és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtContrasenya.Text = "" Then
            sErrors = sErrors & "La contrasenya és obligatòria" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtCorreuE.Text = "" Then
            sErrors = sErrors & "L'adreça del receptor dels correus és obligatòria" & vbCr
            ValidarFormulari = False
        Else
            ' Comprovem que sigui en el format correcte
            If Not Me.esCorreu(Me.txtFromAdreca.Text) Then
                sErrors = sErrors & "L'adreça del receptor dels correus no té el format correcte" & vbCr
                ValidarFormulari = False
            End If
        End If
        If Me.txtPort.Text = "" Then
            sErrors = sErrors & "El port és obligatori" & vbCr
            ValidarFormulari = False
        Else
            If Not IsNumeric(Me.txtPort.Text) Then
                sErrors = sErrors & "El port ha de ser un número" & vbCr
                ValidarFormulari = False
            End If
        End If
        If Me.txtServer.Text = "" Then
            sErrors = sErrors & "L'adreça del servidor és obligatòria" & vbCr
            ValidarFormulari = False
        End If
        '
        If Not ValidarFormulari Then
            MsgBox(sErrors)
            Exit Function
        End If
        ' Si tots els camps són correcte, enviem un correu de prova per comprovar que tot és correcte
        ' En aquest correu, només s'informe que s'ha configurat l'smtp correctament
        ' Si s'envia, les dades són correcte, sinó no
        ' Enviament de correu de prova
        '
        Dim correu As MailMessage = New MailMessage
        Dim client As SmtpClient = New SmtpClient
        correu.To.Add(Me.txtCorreuE.Text)
        ' Adreça del remitent i nom que apareixerà a la safata d'entrada
        correu.From = New MailAddress(Me.txtFromAdreca.Text, Me.txtFromNom.Text)
        correu.Subject = "Configuració del servidor SMTP"
        correu.Body = "La configuració del servidor és correcte <br>"
        correu.SubjectEncoding = System.Text.Encoding.UTF8
        correu.BodyEncoding = System.Text.Encoding.UTF8
        '
        correu.Body = correu.Body & "<br>-------------------<br>"
        correu.Body = correu.Body & Me.txtSignatura.Text
        ' Indica si el cos del missatge és HTML
        correu.IsBodyHtml = True
        ' Configuració servidor SMTP
        ' Credencials del compte
        client.Credentials = New NetworkCredential(Me.txtUsuari.Text, Me.txtContrasenya.Text)
        ' Port del client SMTP
        client.Port = CType(Me.txtPort.Text, Integer)
        ' Adreça del client SMTP
        client.Host = Me.txtServer.Text
        ' Tipus d'encriptació
        client.EnableSsl = False
        Try
            client.Send(correu)
            correu = Nothing
        Catch ex As Exception
            MsgBox("Errors en l'enviament del correu de configuració." & vbCr & "Revisa la configuració i tornar-ho a provar.")
            ValidarFormulari = False
        End Try
        '
    End Function

    Private Function esCorreu(ByVal correu As String)
        Dim sCorreu As String
        Dim rgx As New RegularExpressions.Regex("\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*")
        sCorreu = correu
        If rgx.IsMatch(sCorreu) Then
            esCorreu = True
        Else
            esCorreu = False
        End If
    End Function

    Private Sub CarregarConfiguracio()
        ' Busquem configuracio i la posem
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Dim Config = connexio.ConsultarConfiguracio()
            If Config Is Nothing Then
                Exit Sub
            End If
            ' Treballem amb l'objecte
            oConfiguracio = New Configuracio(Config.lIdConfiguracio, _
                                             Config.sFromAdreca, _
                                             Config.sFromNom, _
                                             Config.sSignatura, _
                                             Config.sServer, _
                                             Config.sCredencialsNom, _
                                             Config.sCredencialsPwd, _
                                             Config.sToAdreca, _
                                             Config.lPort)
            ' Omplim els camps del formulari
            Me.txtFromAdreca.Text = oConfiguracio._fromAdreca
            Me.txtFromNom.Text = oConfiguracio._fromNom
            Me.txtSignatura.Text = oConfiguracio._signatura
            Me.txtServer.Text = oConfiguracio._Server
            Me.txtUsuari.Text = oConfiguracio._usuari
            Me.txtContrasenya.Text = oConfiguracio._contrasenya
            Me.txtCorreuE.Text = oConfiguracio._toAdreca
            Me.txtPort.Text = oConfiguracio._port
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

#End Region

End Class
