﻿Imports Presentació.ServeiGR

Public Class FormMenu

    Dim oMenu As Menu
    Dim llistaPlatsMenu As New List(Of ServeiGR.PlatNET)

    Private Sub FormMenu_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).MenúToolStripMenuItem.Enabled = True
    End Sub

    Private Sub FormMenu_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.RecuperarMenu()
    End Sub

    Private Sub btnActualitzar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActualitzar.Click
        Try
            ' Creem una llista de plats amb els que sestan posats com a menú al grid
            Dim iContador As Long
            ' For de les files del grid
            For iContador = 0 To Me.grdPlats.Rows.Count - 1
                If Me.grdPlats.Rows.Item(iContador).Cells.Item("Menú").Value = True Then
                    Dim p As New ServeiGR.PlatNET()
                    p.idPlat = Me.grdPlats.Rows.Item(iContador).Cells.Item("Id. Plat").Value
                    p.idSeccio = -1
                    llistaPlatsMenu.Add(p)
                End If
            Next
            '
            If Not ValidarFormulari() Then
                Exit Sub
            End If
            ' Entrada del menú
            ' Modifiquem l'objecte Menú
            Me.oMenu._lMinComensals = Me.nmcNumPersones.Value
            Me.oMenu._dPreu = Me.txtPreu.Text
            Me.oMenu._bIVA = If(Me.rbtIVASi.Checked, 1, 0)
            Me.oMenu._bBeguda = If(Me.rbtBegudaSi.Checked, 1, 0)
            Me.oMenu._oPlats = llistaPlatsMenu
            'Me.oMenu = New Menu(-1, _
            '                     Me.nmcNumPersones.Value, _
            '                     Me.txtPreu.Text, _
            '                     If(Me.rbtIVASi.Checked, 1, 0), _
            '                     If(Me.rbtBegudaSi.Checked, 1, 0), _
            '                     llistaPlatsMenu)
            If Me.oMenu.ActualitzarMenu() Then
                MsgBox("Menú actualitzat correctament")
            End If
            ' Buidem oMenu
            Me.oMenu = Nothing
            ' Buidem els plats
            Me.llistaPlatsMenu.Clear()
            ' Recuperem l'últim
            Me.RecuperarMenu()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub

    Private Function ValidarFormulari() As Boolean
        ValidarFormulari = True
        Dim sErrors As String = "Hi ha els següents errors:" & vbCr
        ' Validem nombre de comensals i preu
        If Me.nmcNumPersones.Value < 1 Then
            sErrors = sErrors & "El mínim de persones pel menú menor que 1" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtPreu.Text = "" Then
            sErrors = sErrors & "El preu és obligatori" & vbCr
            ValidarFormulari = False
        Else
            If Not IsNumeric(Me.txtPreu.Text) Then
                sErrors = sErrors & "El preu ha de ser numèric" & vbCr
                ValidarFormulari = False
            Else
                If Not Me.txtPreu.Text > 0 Then
                    sErrors = sErrors & "El preu és incorrecte" & vbCr
                    ValidarFormulari = False
                End If
            End If
        End If
        ' Validem que hi hagi plats
        If Not Me.llistaPlatsMenu.Count > 0 Then
            sErrors = sErrors & "No has posat cap plat al menú" & vbCr
            ValidarFormulari = False
        End If
        '
        If Not ValidarFormulari Then
            MsgBox(sErrors)
        End If
    End Function

    Private Sub RecuperarMenu()
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            ' Recuperem el menú del servei:
            Dim mnu = connexio.ConsultarMenu()
            ' Recuperem la llista de plats i la posem al grid
            Dim llistaPlats = mnu.oPlats
            Me.oMenu = New Menu(mnu.lIdMenu, mnu.lMinComensals, mnu.dPreu, mnu.bIVA, mnu.bBeguda, llistaPlats.ToList)
            '
            Dim ColCheckBox As New DataGridViewCheckBoxColumn
            '
            Me.grdPlats.AutoGenerateColumns = False
            Me.grdPlats.Columns.Clear()
            ' Configurem el grid
            Me.grdPlats.Columns.Add("Id. Plat", "Id. Plat")
            Me.grdPlats.Columns.Add("Secció", "Secció")
            Me.grdPlats.Columns.Add("Nom del plat", "Nom del plat")
            ' Afegim la instància al DataGridView
            Me.grdPlats.Columns.Insert(3, ColCheckBox)
            ' Paràmetres de la columan del checkbox.
            With ColCheckBox
                ' Títol de la columna.
                .HeaderText = "Menú"
                ' Nombre per accedir al contenido por codi.
                .Name = "Menú"
                ' Ample
                .Width = 50
                ' Valor a retornar quan estigui marcada
                .TrueValue = 1
                ' Valor a retornar quan estigui desmarcada
                .FalseValue = 0
                ' La columna és fixa.
                .Frozen = False
                ' Que es pugui marcar i desmarcar.
                .ReadOnly = False
            End With
            ' Posem les mides de les columnes
            Me.grdPlats.Columns("Id. Plat").Width = 85
            Me.grdPlats.Columns("Secció").Width = 100
            Me.grdPlats.Columns("Nom del plat").Width = 238
            '
            Me.grdPlats.Columns("Nom del plat").DataPropertyName = "nomCat"
            Me.grdPlats.Columns("Nom del plat").ReadOnly = True
            Me.grdPlats.Columns("Id. Plat").DataPropertyName = "idPlat"
            Me.grdPlats.Columns("Id. Plat").ReadOnly = True
            Me.grdPlats.Columns("Secció").DataPropertyName = "sNomSeccio"
            Me.grdPlats.Columns("Secció").ReadOnly = True
            Me.grdPlats.Columns("Menú").DataPropertyName = "bEsMenu"
            Me.grdPlats.Columns("Menú").ReadOnly = False
            '
            Me.grdPlats.DataSource = llistaPlats
            '
            ' omplim els textbox
            '
            Me.txtPreu.Text = Me.oMenu._dPreu
            Me.nmcNumPersones.Value = Me.oMenu._lMinComensals
            If Me.oMenu._bIVA Then
                Me.rbtIVASi.Checked = True
            Else
                Me.rbtIVANo.Checked = True
            End If
            If Me.oMenu._bBeguda Then
                Me.rbtBegudaSi.Checked = True
            Else
                Me.rbtBegudaNo.Checked = True
            End If
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    
    Private Sub grdPlats_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles grdPlats.DoubleClick
        ' Al doble clic, obrir el formulari del plat
        Dim idPlat As Long
        idPlat = Me.grdPlats.Rows(Me.grdPlats.CurrentRow.Index).Cells("Id. Plat").Value
        ' Tancar formulari actiu
        If Not Me.ActiveMdiChild Is Nothing Then
            Me.ActiveMdiChild.Close()
        End If
        ' Habilitar i deshabilitar el menú
        CType(Me.MdiParent, FormInici).AltaPlatToolStripMenuItem.Enabled = False
        CType(Me.MdiParent, FormInici).MenúToolStripMenuItem.Enabled = True
        ' Obrir el formulari que toca
        Dim oForm As New FormPlatAlta(idPlat)
        oForm.MdiParent = Me.MdiParent
        oForm.Show()
        oForm.Left = 0
        oForm.Top = 0
        ''
    End Sub
End Class