﻿Imports Presentació.ServeiGR

Public Class FormOfertaAlta

    Private mode As Long = 1 ' 0 modifica, 1 alta
    Private lIdOferta As Long = -1
    Private oOferta As Oferta

    Private Sub FormOfertaAlta_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).AltaOfertaToolStripMenuItem.Enabled = True

    End Sub

    Public Sub New()
        ' Llamada necesaria para el Diseñador de Windows Forms.
        InitializeComponent()
        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        Me.Inicialitzar()
    End Sub

    Public Sub New(ByVal lIdOferta As Long)
        ' Constructor utilitzat per carregar les dades quan fan el doble click al llistat
        InitializeComponent()
        '
        Me.lIdOferta = lIdOferta
        Me.mode = 0
        Me.CarregarDadesOferta()
    End Sub

    Private Sub Inicialitzar()
        Me.NetejarFormulari()
        Me.mode = 1
        Me.btnAltaAct.Text = "Alta"
        Me.oOferta = Nothing
    End Sub

    Private Sub NetejarFormulari()
        Me.txtAssumpteCat.Text = ""
        Me.txtAssumpteCas.Text = ""
        Me.txtAssumpteAng.Text = ""
        Me.dtpDataOferta.Text = ""
        Me.dtpDataCaducitat.Text = ""
        Me.txtContingutCat.Text = ""
        Me.txtContingutCas.Text = ""
        Me.txtContingutAng.Text = ""
        Me.mode = 1
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Inicialitzar()
        Me.HabilitarControls(True)
    End Sub

    Private Sub btnAltaAct_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAltaAct.Click
        If Not Me.ValidarFormulari() Then
            Exit Sub
        End If
        '
        Select Case mode
            ' Modificació
            Case 0
                If Not oOferta.EsPotEsborrarOferta() Then
                    MsgBox("L'oferta ja ha estat enviada als destinataris i no es pot esborrar ni modificar")
                    Exit Sub
                End If
                oOferta._assumpteCat = Me.txtAssumpteCat.Text
                oOferta._assumpteCas = Me.txtAssumpteCas.Text
                oOferta._assumpteAng = Me.txtAssumpteAng.Text
                oOferta._dataOferta = Me.dtpDataOferta.Text
                oOferta._dataCaducitat = Me.dtpDataCaducitat.Text
                oOferta._contingutCat = Me.txtContingutCat.Text.Replace(vbCrLf, "<br />")
                oOferta._contingutCas = Me.txtContingutCas.Text.Replace(vbCrLf, "<br />")
                oOferta._contingutAng = Me.txtContingutAng.Text.Replace(vbCrLf, "<br />")
                '
                If oOferta.ModificarOferta() Then
                    MsgBox("Oferta modificada correctament")
                End If
                ' Alta
            Case 1
                Dim oferta As New Oferta(-1, _
                                         Me.txtAssumpteCat.Text, _
                                         Me.txtAssumpteCas.Text, _
                                         Me.txtAssumpteAng.Text, _
                                         Me.dtpDataOferta.Text, _
                                         Me.dtpDataCaducitat.Text, _
                                         Me.txtContingutCat.Text.Replace(vbCrLf, "<br />"), _
                                         Me.txtContingutCas.Text.Replace(vbCrLf, "<br />"), _
                                         Me.txtContingutAng.Text.Replace(vbCrLf, "<br />"))
                If oferta.AfegirOferta() Then
                    MsgBox("Oferta donada d'alta correctament")
                End If
                Me.NetejarFormulari()
        End Select
    End Sub

    Private Function ValidarFormulari() As Boolean
        ValidarFormulari = True
        Dim sErrors As String = "Hi ha els següents errors:" & vbCr
        If Me.txtAssumpteCat.Text = "" Then
            sErrors = sErrors & "L'assumpte en català és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtAssumpteCas.Text = "" Then
            sErrors = sErrors & "L'assumpte en castellà és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtAssumpteAng.Text = "" Then
            sErrors = sErrors & "L'assumpte en anglès és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.dtpDataOferta.Text = "" Then
            sErrors = sErrors & "La data és obligatòria" & vbCr
            ValidarFormulari = False
        Else
            If Not IsDate(Me.dtpDataOferta.Text) Then
                sErrors = sErrors & "Error en la data de l'oferta" & vbCr
                ValidarFormulari = False
            End If
        End If
        If Me.dtpDataCaducitat.Text = "" Then
            sErrors = sErrors & "La data de caducitat és obligatòria" & vbCr
            ValidarFormulari = False
        Else
            If Not IsDate(Me.dtpDataCaducitat.Text) Then
                sErrors = sErrors & "Error en la data de caducitat" & vbCr
                ValidarFormulari = False
            End If
        End If
        If Me.txtContingutCat.Text = "" Then
            sErrors = sErrors & "El contingut en català és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtContingutCas.Text = "" Then
            sErrors = sErrors & "El contingut en castellà és obligatori" & vbCr
            ValidarFormulari = False
        End If
        If Me.txtContingutAng.Text = "" Then
            sErrors = sErrors & "El contingut en anglès és obligatori" & vbCr
            ValidarFormulari = False
        End If
        '
        If Not ValidarFormulari Then
            MsgBox(sErrors)
        End If
    End Function

    Private Sub CarregarDadesOferta()
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Dim oferta = connexio.ConsultarOferta(Me.lIdOferta)
            ' Treballem amb l'objecte
            oOferta = New Oferta(Me.lIdOferta, _
                                 oferta.sAssumpteCat, _
                                 oferta.sAssumpteCas, _
                                 oferta.sAssumpteAng, _
                                 oferta.dData, _
                                 oferta.dDataCaducitat, _
                                 oferta.sContingutCat, _
                                 oferta.sContingutCas, _
                                 oferta.sContingutAng)
            ' Carrega les dades
            Me.txtAssumpteCat.Text = oferta.sAssumpteCat
            Me.txtAssumpteCas.Text = oferta.sAssumpteCas
            Me.txtAssumpteAng.Text = oferta.sAssumpteAng
            Me.dtpDataOferta.Text = oferta.dData
            Me.dtpDataCaducitat.Text = oferta.dDataCaducitat
            Me.txtContingutCat.Text = oferta.sContingutCat.ToString.Replace("<br />", vbCrLf)
            Me.txtContingutCas.Text = oferta.sContingutCas.ToString.Replace("<br />", vbCrLf)
            Me.txtContingutAng.Text = oferta.sContingutAng.ToString.Replace("<br />", vbCrLf)
            ' Posem el botó a actualitzar
            Me.btnAltaAct.Text = "Actualitzar registre"
            '
            ' Si l'oferta ja ha estat enviada, deshabilitem els controls per tal que no puguin modificar res
            If Not oOferta.EsPotEsborrarOferta Then
                Me.HabilitarControls(False)
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub btnEsborrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEsborrar.Click
        ' Mirar que l'objecte no estigui a null i esborrar-lo
        If Not oOferta Is Nothing Then
            If Not oOferta.EsPotEsborrarOferta() Then
                MsgBox("L'oferta ja ha estat enviada als destinataris i no es pot esborrar ni modificar")
                Exit Sub
            End If
            Dim iResult As Integer
            iResult = MsgBox("S'eliminanarà una oferta, estàs segur?", MsgBoxStyle.YesNo)
            If iResult = 6 Then
                If oOferta.EsborrarOferta() Then
                    MsgBox("Oferta esborrada")
                End If
                Me.Inicialitzar()
                oOferta = Nothing
            End If
        Else
            MsgBox("Falta escollir una oferta")
        End If
    End Sub

    Private Sub HabilitarControls(ByVal operacio As Boolean)
        '
        Me.txtAssumpteCat.Enabled = operacio
        Me.txtAssumpteCas.Enabled = operacio
        Me.txtAssumpteAng.Enabled = operacio
        Me.txtContingutCat.Enabled = operacio
        Me.txtContingutCas.Enabled = operacio
        Me.txtContingutAng.Enabled = operacio
        Me.dtpDataOferta.Enabled = operacio
        Me.dtpDataCaducitat.Enabled = operacio
    End Sub

End Class