﻿Imports Presentació.ServeiGR
Imports System.Net
Imports System.Net.Mail
Imports System.Net.Mime
Imports System.Text.RegularExpressions

Public Class FormOfertaLlistar

    Private Sub FormOfertaLlistar_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).LlistarOfertesToolStripMenuItem.Enabled = True
    End Sub

    Private Sub FormOfertaLlistar_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.RecuperarOfertes()
    End Sub

    Private Sub RecuperarOfertes()
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            ' Recuperem el llistat d'ofertes del del servei:
            Dim llistatOfertes = connexio.LlistarOfertes()
            '
            Dim ColCheckBox As New DataGridViewCheckBoxColumn
            '
            Me.grdOfertes.AutoGenerateColumns = False
            Me.grdOfertes.Columns.Clear()
            ' Configurem el grid
            Me.grdOfertes.Columns.Add("Id. Oferta", "Id. Oferta")
            Me.grdOfertes.Columns.Add("Data", "Data")
            Me.grdOfertes.Columns.Add("Data de caducitat", "Data de caducitat")
            Me.grdOfertes.Columns.Add("Assumpte", "Assumpte")
            ' Afegim la instància al DataGridView
            Me.grdOfertes.Columns.Insert(4, ColCheckBox)
            ' Paràmetres de la columan del checkbox.
            With ColCheckBox
                ' Títol de la columna.
                .HeaderText = "Enviar"
                ' Nombre per accedir al contenido por codi.
                .Name = "Enviar"
                ' Ample
                .Width = 45
                ' Valor a retornar quan estigui marcada
                .TrueValue = 1
                ' Valor a retornar quan estigui desmarcada
                .FalseValue = 0
                ' La columna és fixa.
                .Frozen = False
                ' Que es pugui marcar i desmarcar.
                .ReadOnly = False
            End With
            ' Posem les mides de les columnes
            Me.grdOfertes.Columns("Id. Oferta").Width = 80
            Me.grdOfertes.Columns("Data").Width = 50
            Me.grdOfertes.Columns("Data de caducitat").Width = 120
            Me.grdOfertes.Columns("Assumpte").Width = 194
            '
            Me.grdOfertes.Columns("Id. Oferta").DataPropertyName = "lIdOferta"
            Me.grdOfertes.Columns("Id. Oferta").ReadOnly = True
            Me.grdOfertes.Columns("Data").DataPropertyName = "dData"
            Me.grdOfertes.Columns("Data").ReadOnly = True
            Me.grdOfertes.Columns("Data de caducitat").DataPropertyName = "dDataCaducitat"
            Me.grdOfertes.Columns("Data de caducitat").ReadOnly = True
            Me.grdOfertes.Columns("Assumpte").DataPropertyName = "sAssumpteCat"
            Me.grdOfertes.Columns("Assumpte").ReadOnly = True
            '
            Me.grdOfertes.DataSource = llistatOfertes
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub grdOfertes_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles grdOfertes.DoubleClick
        ' Al doble clic, obrir el formulari d'Alta de cambrers
        Dim lIdOferta As Long
        lIdOferta = Me.grdOfertes.Rows(Me.grdOfertes.CurrentRow.Index).Cells("Id. Oferta").Value
        ' Tancar formulari actiu
        If Not Me.ActiveMdiChild Is Nothing Then
            Me.ActiveMdiChild.Close()
        End If
        ' Habilitar i deshabilitar el menú
        CType(Me.MdiParent, FormInici).AltaOfertaToolStripMenuItem.Enabled = False
        CType(Me.MdiParent, FormInici).LlistarOfertesToolStripMenuItem.Enabled = True
        ' Obrir el formulari que toca
        Dim oForm As New FormOfertaAlta(lIdOferta)
        oForm.MdiParent = Me.MdiParent
        oForm.Show()
        oForm.Left = 0
        oForm.Top = 0
        '
    End Sub

    Private Sub btnEnviar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnviar.Click
        Dim iResult As Integer
        iResult = MsgBox("S'enviaran les ofertes que no estan caducades als destinataris, n'estàs segur?", MsgBoxStyle.YesNo)
        If iResult = 6 Then
            Me.Habilitar(False)
            Me.EnviamentOfertes()
            Me.Habilitar(True)
            Me.RecuperarOfertes()
        End If
    End Sub

    Private Sub EnviamentOfertes()
        ' Enviament de les ofertes al destinatari
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Dim sMissatge As String = "No hi ha ofertes per enviar o destinataris"
        Try
            Dim llistatOfertes = connexio.LlistarOfertes()
            Dim llistatDestinataris = connexio.LlistaRegistrats()
            Dim Config = connexio.ConsultarConfiguracio()
            If Config Is Nothing Then
                MsgBox("Per enviar les ofertes, cal primer que configuris el servidor SMTP")
                Exit Sub
            End If
            '
            ' Carreguem les dades de la configuració
            Dim oConfiguracio = New Configuracio(Config.lIdConfiguracio, _
                                         Config.sFromAdreca, _
                                         Config.sFromNom, _
                                         Config.sSignatura, _
                                         Config.sServer, _
                                         Config.sCredencialsNom, _
                                         Config.sCredencialsPwd, _
                                         Config.sToAdreca, _
                                         Config.lPort)
            ' Fem un for del grid per veure quins checks estan marcat
            Dim lContadorGrid As Long = -1
            ' For de les files del grid
            For lContadorGrid = 0 To Me.grdOfertes.Rows.Count - 1
                ' Mirem si estan marcades
                If Me.grdOfertes.Rows.Item(lContadorGrid).Cells.Item("Enviar").Value = 1 Then
                    ' Recuperem l'oferta
                    Dim oOfertaEnviament = connexio.ConsultarOferta(CType(Me.grdOfertes.Rows.Item(lContadorGrid).Cells.Item("Id. Oferta").Value, Long))
                    ' Recuperem els destinataris (ull amb la llengua amb la qual s'han registrat)
                    For Each destinatari In llistatDestinataris
                        If oOfertaEnviament.dDataCaducitat >= Date.Today() Then
                            If Me.EsMail(destinatari.sCorreuElectronic) Then
                                Dim correu As MailMessage = New MailMessage
                                ' Destinatari
                                correu.To.Add(destinatari.sCorreuElectronic)
                                ' Adreça del remitent i nom que apareixerà a la safata d'entrada
                                correu.From = New MailAddress(oConfiguracio._fromAdreca, oConfiguracio._fromNom)
                                ' Propietats del correu en funció de la llengua del destinatari
                                Select Case destinatari.sLlengua
                                    Case "CAT"
                                        correu.Subject = oOfertaEnviament.sAssumpteCat
                                        correu.Body = "Benvolgut/da " & destinatari.sNom & " " & destinatari.sCognom & "," & "<br>"
                                        correu.Body = correu.Body & oOfertaEnviament.sContingutCat
                                    Case "CAS"
                                        correu.Subject = oOfertaEnviament.sAssumpteCas
                                        correu.Body = "Apreciado/da " & destinatari.sNom & " " & destinatari.sCognom & "," & "<br>"
                                        correu.Body = correu.Body & oOfertaEnviament.sContingutCas
                                    Case "ANG"
                                        correu.Subject = oOfertaEnviament.sAssumpteAng
                                        correu.Body = "Dear " & destinatari.sNom & " " & destinatari.sCognom & "," & "<br>"
                                        correu.Body = correu.Body & oOfertaEnviament.sContingutAng
                                    Case Else
                                        correu.Subject = oOfertaEnviament.sAssumpteCat
                                        correu.Body = "Benvolgut/da " & destinatari.sNom & " " & destinatari.sCognom & "," & "<br>"
                                        correu.Body = correu.Body & oOfertaEnviament.sContingutCat
                                End Select
                                '
                                correu.SubjectEncoding = System.Text.Encoding.UTF8
                                correu.BodyEncoding = System.Text.Encoding.UTF8
                                '
                                correu.Body = correu.Body & "<br>-------------------<br>"
                                correu.Body = correu.Body & oConfiguracio._signatura
                                ' Indica si el cos del missatge és HTML
                                correu.IsBodyHtml = True
                                ' Configuració servidor SMTP
                                Dim client As SmtpClient = New SmtpClient
                                ' Credencials del compte
                                client.Credentials = New NetworkCredential(oConfiguracio._usuari, oConfiguracio._contrasenya)
                                ' Port del client SMTP
                                client.Port = oConfiguracio._port
                                ' Adreça del client SMTP
                                client.Host = oConfiguracio._Server
                                ' Tipus d'encriptació
                                client.EnableSsl = False
                                ' Fem un try catch dins d'un try cath perquè tot i que el correu pot ser de format correcte
                                ' podria no existir, cosa que el retornaria i faria que es parés el procés deixant
                                ' la resta de destinataria sense l'oferta
                                Dim oEnviament As New Enviament(CType(Me.grdOfertes.Rows.Item(lContadorGrid).Cells.Item("Id. Oferta").Value, Long), _
                                                                destinatari.lIdPersona)
                                oEnviament.InserirEnviament()
                                Try
                                    client.Send(correu)
                                    correu = Nothing
                                Catch ex As Exception
                                    ' TODO: Fora bo fer un log d'errors. Es descarta el messagebox perquè pararia el procés
                                End Try
                            End If
                            sMissatge = "Ofertes enviades"
                        End If
                    Next
                End If
            Next
            '
            MsgBox(sMissatge)
        Catch ex As Exception
            Me.Habilitar(True)
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
        
        '
    End Sub

    Private Function EsMail(ByVal sMail As String) As Boolean
        ' retorna true o false   
        Return Regex.IsMatch(sMail, "^([\w-]+\.)*?[\w-]+@[\w-]+\.([\w-]+\.)*?[\w]+$")
    End Function

    Private Sub Habilitar(ByVal bMode As Boolean)
        CType(Me.MdiParent, FormInici).CambrersToolStripMenuItem.Enabled = bMode
        CType(Me.MdiParent, FormInici).CartaToolStripMenuItem.Enabled = bMode
        CType(Me.MdiParent, FormInici).TaulesToolStripMenuItem.Enabled = bMode
        CType(Me.MdiParent, FormInici).MenúToolStripMenuItem.Enabled = bMode
        CType(Me.MdiParent, FormInici).OfertesToolStripMenuItem.Enabled = bMode
        CType(Me.MdiParent, FormInici).SortirToolStripMenuItem.Enabled = bMode
        Me.btnEnviar.Enabled = bMode
    End Sub
End Class