﻿Imports Presentació.ServeiGR
Imports System.IO
Imports System.Net

Public Class FormPlatAlta

    Private mode As Long = 1 ' 0 modifica, 1 alta
    Private lIdPlat As Long = -1
    Private oPlat As Plat
    Dim foto As OpenFileDialog

    Private Sub FormPlatAlta_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).AltaPlatToolStripMenuItem.Enabled = True
    End Sub

    Public Sub New()
        ' Llamada necesaria para el Diseñador de Windows Forms.
        InitializeComponent()
        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        Me.Inicialitzar()
    End Sub

    Public Sub New(ByVal idPlat As Long)
        ' Constructor utilitzat per carregar les dades quan fan el doble click al llistat
        InitializeComponent()
        '
        Me.lIdPlat = idPlat
        Me.mode = 0
        Me.OmplirCombo()
        Me.CarregarDadesPlat()
    End Sub

    Private Sub Inicialitzar()
        Me.NetejarFormulari()
        Me.mode = 1
        Me.btnAltaAct.Text = "Alta"
        Me.oPlat = Nothing
    End Sub

    Private Sub NetejarFormulari()
        Me.txtNomCat.Text = ""
        Me.txtNomCas.Text = ""
        Me.txtNomAng.Text = ""
        Me.nmcMinPersones.Value = 1
        Me.txtPreuPlat.Text = ""
        Me.txtFotografia.Text = ""
        Me.OmplirCombo()
        Me.mode = 1
        Me.txtNomCat.Focus()
    End Sub


    Private Sub OmplirCombo()
        Dim connexio As New ServeiGR.ServeiClient
        Try
            '
            Me.cboSeccions.DisplayMember = "nomCat"
            Me.cboSeccions.ValueMember = "idSeccio"
            Me.cboSeccions.DataSource = connexio.LlistaSeccions("cbo")
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Inicialitzar()
    End Sub

    Private Sub btnAltaAct_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAltaAct.Click
        If Not Me.Validar() Then
            Exit Sub
        End If
        '
        Try
            Select Case mode
                ' Modificació
                Case 0
                    If Me.txtFotografia.Text <> "" Then
                        Dim fs As New FileStream(Me.txtFotografia.Text, FileMode.OpenOrCreate, FileAccess.ReadWrite)
                        fs.Position = 0
                        Dim imgLength As Integer = CInt(fs.Length)
                        Dim bytes(0 To imgLength - 1) As Byte
                        fs.Read(bytes, 0, imgLength)
                        fs.Close()
                        oPlat._imatge = bytes
                    End If
                    oPlat._nomCat = Me.txtNomCat.Text
                    oPlat._nomCas = Me.txtNomCas.Text
                    oPlat._nomAng = Me.txtNomAng.Text
                    oPlat._minPersones = Me.nmcMinPersones.Text
                    oPlat._preu = Me.txtPreuPlat.Text
                    oPlat._urlFoto = Me.NomFoto(Me.txtFotografia.Text)
                    oPlat._idSeccio = Me.cboSeccions.SelectedValue

                    If oPlat.ModificarPlat() Then
                        MsgBox("Plat modificat correctament")
                    End If
                    ' Alta
                Case 1
                    Dim plat As Plat
                    '---------------------------------------------
                    If Me.txtFotografia.Text <> "" Then
                        Dim fs As New FileStream(Me.txtFotografia.Text, FileMode.OpenOrCreate, FileAccess.ReadWrite)
                        fs.Position = 0
                        Dim imgLength As Integer = CInt(fs.Length)
                        Dim bytes(0 To imgLength - 1) As Byte
                        fs.Read(bytes, 0, imgLength)
                        fs.Close()
                        plat = New Plat(-1, Me.txtNomCat.Text, _
                                         Me.txtNomCas.Text, _
                                         Me.txtNomAng.Text, _
                                         Me.nmcMinPersones.Value, _
                                         Me.txtPreuPlat.Text, _
                                         Me.NomFoto(Me.txtFotografia.Text), _
                                         Me.cboSeccions.SelectedValue, _
                                         If(Me.txtFotografia.Text <> "", bytes, Nothing))
                    Else
                        plat = New Plat(-1, Me.txtNomCat.Text, _
                                         Me.txtNomCas.Text, _
                                         Me.txtNomAng.Text, _
                                         Me.nmcMinPersones.Value, _
                                         Me.txtPreuPlat.Text, _
                                         Me.NomFoto(Me.txtFotografia.Text), _
                                         Me.cboSeccions.SelectedValue)
                    End If
                    '---------------------------------------------

                    If Plat.AfegirPlat() Then
                        MsgBox("Plat donat d'alta correctament")
                    End If
                    Me.NetejarFormulari()
            End Select
            ' Aquí pujaríem la foto si el camp de la foto hi ha fotografia
            ' Caldria canviar la ruta físic per la vitual del servidor
            'If Me.txtFotografia.Text <> "" Then
            '    'My.Computer.Network.UploadFile(Me.txtFotografia.Text, "C:\Documents and Settings\Carles\Mis documentos\Visual Studio 2008\TFC\GestioRestaurant\PRJWeb\GRPresentacio\GRPresentacio\imatges\plats\" & Me.NomFoto(Me.txtFotografia.Text))
            'End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        '
    End Sub

    Public Shared Function Image2Bytes(ByVal img As Image) As Byte()
        Dim sTemp As String = Path.GetTempFileName()
        Dim fs As New FileStream(sTemp, FileMode.OpenOrCreate, FileAccess.ReadWrite)
        img.Save(fs, System.Drawing.Imaging.ImageFormat.Png)
        fs.Position = 0
        '
        Dim imgLength As Integer = CInt(fs.Length)
        Dim bytes(0 To imgLength - 1) As Byte
        fs.Read(bytes, 0, imgLength)
        fs.Close()
        Return bytes
    End Function

    Private Function Validar() As Boolean
        Validar = True
        Dim sErrors As String = "Hi ha els següents errors:" & vbCr
        If Me.txtNomCat.Text = "" Then
            sErrors = sErrors & "El nom en català és obligatori" & vbCr
            Validar = False
        End If
        If Me.txtNomCas.Text = "" Then
            sErrors = sErrors & "El nom en castellà és obligatori" & vbCr
            Validar = False
        End If
        If Me.txtNomAng.Text = "" Then
            sErrors = sErrors & "El nom en anglès és obligatori" & vbCr
            Validar = False
        End If
        If Me.txtPreuPlat.Text = "" Then
            sErrors = sErrors & "El preu és obligatori" & vbCr
            Validar = False
        Else
            If Not IsNumeric(Me.txtPreuPlat.Text) Then
                sErrors = sErrors & "El preu ha de ser numèric" & vbCr
                Validar = False
            End If
        End If
        If Not Me.cboSeccions.SelectedValue > 0 Then
            sErrors = sErrors & "Has d'escollir una secció pel plat" & vbCr
            Validar = False
        End If
        '
        If Not Validar Then
            MsgBox(sErrors)
        End If
    End Function

    Private Sub CarregarDadesPlat()
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            Dim plat = connexio.ConsultarPlat(Me.lIdPlat)
            ' Treballem amb l'objecte
            oPlat = New Plat(Me.lIdPlat, plat.nomCat, plat.nomCas, plat.nomAng, plat.minPersones, plat.preu, plat.urlFoto, plat.idSeccio)
            ' Carrega les dades
            Me.txtNomCat.Text = oPlat._nomCat
            Me.txtNomCas.Text = oPlat._nomCas
            Me.txtNomAng.Text = oPlat._nomAng
            Me.nmcMinPersones.Value = oPlat._minPersones
            Me.txtPreuPlat.Text = oPlat._preu
            Me.txtFotografia.Text = oPlat._urlFoto
            Me.cboSeccions.SelectedValue() = oPlat._idSeccio
            ' Posem el botó a actualitzar
            Me.btnAltaAct.Text = "Actualitzar registre"
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub btnEsborrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEsborrar.Click
        ' Mirar que l'objecte no estigui a null i esborrar-lo
        If Not oPlat Is Nothing Then
            If Not oPlat.EsPotEsborrarPlat() Then
                MsgBox("El plat " & Me.oPlat._nomCat & " no es pot esborrar perquè hi ha comandes o menús que en depenen")
                Exit Sub
            End If
            '
            Dim iResult As Integer
            iResult = MsgBox("S'eliminanarà un plat, estàs segur?", MsgBoxStyle.YesNo)
            If iResult = 6 Then
                If Me.oPlat.EsborrarPlat() Then
                    MsgBox("Plat esborrat")
                End If
                Me.Inicialitzar()
                oPlat = Nothing
            End If
        Else
            MsgBox("Falta escollir plat")
        End If
    End Sub

    Private Sub btnFoto_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFoto.Click
        Dim fitxer As Stream = Nothing
        Dim DialegFitxer As New OpenFileDialog()

        DialegFitxer.InitialDirectory = "c:\"
        DialegFitxer.Filter = "JPEG (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        DialegFitxer.FilterIndex = 2
        DialegFitxer.RestoreDirectory = True

        If DialegFitxer.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                fitxer = DialegFitxer.OpenFile()
                If (fitxer IsNot Nothing) Then
                    ' Posem la ruta al textBox
                    Me.txtFotografia.Text = DialegFitxer.FileName
                End If
            Catch Ex As Exception
                MessageBox.Show("No es pot llegir la imatge del disc. Error: " & Ex.Message)
            Finally
                If (fitxer IsNot Nothing) Then
                    fitxer.Close()
                End If
            End Try
        Else
            ' Esborrem
            Me.txtFotografia.Text = ""
        End If
    End Sub

    Private Function NomFoto(ByVal sRutaFoto As String) As String
        NomFoto = ""
        If sRutaFoto <> "" Then
            Dim parts() As String
            parts = Split(sRutaFoto, "\")
            NomFoto = parts(parts.Count - 1)
        End If
    End Function

End Class