﻿Imports Presentació.ServeiGR

Public Class FormSeccions

    Private oSeccio As Seccio
    Private mode As Long = 1 ' 0 modifica, 1 alta

    Private Sub FormSeccions_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).SeccionsToolStripMenuItem.Enabled = True
    End Sub

    Private Sub FormSeccions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.OmplirGrid()
    End Sub

    Private Sub OmplirGrid()
        Dim connexio As New ServeiGR.ServeiClient
        Try
            Me.grdSeccions.AutoGenerateColumns = False
            Me.grdSeccions.Columns.Clear()
            ' Configurem el grid
            Me.grdSeccions.Columns.Add("Id. Secció", "Id. Secció")
            Me.grdSeccions.Columns.Add("Odre", "Ordre")
            Me.grdSeccions.Columns.Add("Nom CAT", "Nom CAT")
            Me.grdSeccions.Columns.Add("Nom CAS", "Nom CAS")
            Me.grdSeccions.Columns.Add("Nom ANG", "Nom ANG")
            ' Posem les mides de les columnes
            Me.grdSeccions.Columns("Id. Secció").Width = 90
            Me.grdSeccions.Columns("Odre").Width = 95
            Me.grdSeccions.Columns("Nom CAT").Width = 104
            Me.grdSeccions.Columns("Nom CAS").Width = 100
            Me.grdSeccions.Columns("Nom ANG").Width = 100
            '
            Me.grdSeccions.Columns("Id. Secció").DataPropertyName = "idSeccio"
            Me.grdSeccions.Columns("Odre").DataPropertyName = "ordre"
            Me.grdSeccions.Columns("Nom CAT").DataPropertyName = "nomCat"
            Me.grdSeccions.Columns("Nom CAS").DataPropertyName = "nomCas"
            Me.grdSeccions.Columns("Nom ANG").DataPropertyName = "nomAng"
            '
            Me.grdSeccions.DataSource = connexio.LlistaSeccions("grd")
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub btnAlta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAlta.Click
        If Not Validar() Then
            Exit Sub
        End If
        Select Case Me.mode
            Case 0
                oSeccio._nomCat = Me.txtNomCat.Text
                oSeccio._nomCas = Me.txtNomCas.Text
                oSeccio._nomAng = Me.txtNomAng.Text
                oSeccio._Ordre = Me.txtOrdre.Text
                If oSeccio.ModificarSeccio() Then
                    MsgBox("Secció modificada correctament")
                End If
            Case 1
                Dim sec As New Seccio(-1, Me.txtOrdre.Text, Me.txtNomCat.Text, Me.txtNomCas.Text, Me.txtNomAng.Text)
                If sec.AfegirSeccio() Then
                    MsgBox("Secció donada d'alta correctament")
                End If
        End Select
        
        Me.NetejarFormulari()
        Me.OmplirGrid()
    End Sub

    Private Function Validar() As Boolean
        Validar = True
        Dim sErrors = "Hi ha els següents errors" & vbCr
        '
        If Me.txtOrdre.Text = "" Then
            sErrors = sErrors & "L'ordre és obligatori" & vbCr
            Validar = False
        Else
            If Not IsNumeric(Me.txtOrdre.Text) Then
                sErrors = sErrors & "L'ordre ha de ser un número" & vbCr
                Validar = False
            End If
        End If
        If Me.txtNomCat.Text = "" Then
            sErrors = sErrors & "El nom en català  és obligatori" & vbCr
            Validar = False
        End If
        If Me.txtNomCas.Text = "" Then
            sErrors = sErrors & "El nom en castellà és obligatori" & vbCr
            Validar = False
        End If
        If Me.txtNomAng.Text = "" Then
            sErrors = sErrors & "El nom en anglès és obligatori" & vbCr
            Validar = False
        End If
        '
        If Not Validar Then
            MsgBox(sErrors)
        End If

    End Function

    Private Sub NetejarFormulari()
        '
        Me.txtOrdre.Text = ""
        Me.txtNomCat.Text = ""
        Me.txtNomCas.Text = ""
        Me.txtNomAng.Text = ""
        Me.btnAlta.Text = "Alta"
        Me.mode = 1
        '
    End Sub

    Private Sub ModificarSeccióToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ModificarSeccióToolStripMenuItem.Click
        Dim idSeccio As Long
        idSeccio = Me.grdSeccions.Rows(Me.grdSeccions.CurrentRow.Index).Cells("Id. Secció").Value
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            ' Carreguem les dades als textboxs
            Dim seccio = connexio.ConsultarSeccio(idSeccio)
            oSeccio = New Seccio(seccio.idSeccio, seccio.ordre, seccio.nomCat, seccio.nomCas, seccio.nomAng)
            '
            Me.txtOrdre.Text = oSeccio._Ordre
            Me.txtNomCat.Text = oSeccio._nomCat
            Me.txtNomCas.Text = oSeccio._nomCas
            Me.txtNomAng.Text = oSeccio._nomAng
            '
            ' Posem el botó a update
            Me.mode = 0
            Me.btnAlta.Text = "Actualitzar"
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
        '
    End Sub

    Private Sub EsborrarSeccióToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EsborrarSeccióToolStripMenuItem.Click
        Dim idSeccio As Long
        idSeccio = Me.grdSeccions.Rows(Me.grdSeccions.CurrentRow.Index).Cells("Id. Secció").Value
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            ' Carreguem les dades als textboxs
            Dim seccio = connexio.ConsultarSeccio(idSeccio)
            oSeccio = New Seccio(seccio.idSeccio, seccio.ordre, seccio.nomCat, seccio.nomCas, seccio.nomAng)
            ' Validem que no la secció no tingui plats
            Dim llistatPlast = connexio.LlistarPlats(seccio.idSeccio)
            If llistatPlast.Count > 0 Then
                MsgBox("La secció " & seccio.nomCat & " no es pot eliminar perquè té plats assignats")
                Exit Sub
            End If
            '
            If Not IsDBNull(oSeccio) Then
                Dim iResult As Integer
                iResult = MsgBox("S'eliminanarà la secció " & oSeccio._nomCat & ", estàs segur?", MsgBoxStyle.YesNo)
                If iResult = 6 Then
                    If oSeccio.EsborrarSeccio() Then
                        MsgBox("Secció esborrada")
                    End If
                    Me.NetejarFormulari()
                    Me.OmplirGrid()
                End If
            Else
                MsgBox("Falta escollir secció")
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

End Class