﻿Imports Presentació.ServeiGR

Public Class FormTaules

    Private oTaula As Taula
    Private mode As Long = 1 ' 0 modifica, 1 alta

    Private Sub FormTaules_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CType(Me.MdiParent, FormInici).TaulesToolStripMenuItem.Enabled = True
    End Sub

    Private Sub btnAlta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAlta.Click
        If Not Validar() Then
            Exit Sub
        End If
        Select Case Me.mode
            Case 0
                oTaula._numSeients = Me.NmcSeientsTaula.Value
                If oTaula.ModificarTaula() Then
                    MsgBox("Taula modificada correctament")
                End If
            Case 1
                Dim taula As New Taula(-1, Me.NmcSeientsTaula.Value)
                If taula.AfegirTaula Then
                    MsgBox("Taula donada d'alta correctament")
                End If
        End Select
        '
        Me.NetejarFormulari()
        '
    End Sub

    Private Function Validar() As Boolean
        Validar = True
        Dim sErrors As String = "Hi ha els següents errors:" & vbCr
        ' Només cal validar que el nombre de seients sigui més gran que 0
        If Not Me.NmcSeientsTaula.Value > 1 Then
            sErrors = sErrors & "El nombre ha de ser superior a 0"
            Validar = False
        End If
        If Not Validar Then
            MsgBox(sErrors)
        End If
    End Function

    Private Sub NetejarFormulari()
        Me.btnAlta.Text = "Alta"
        Me.NmcSeientsTaula.Value = 2
        Me.mode = 1
        Me.OmplirGrid()
    End Sub

    Private Sub OmplirGrid()
        Dim connexio As New ServeiGR.ServeiClient
        Try
            Me.grdTaules.AutoGenerateColumns = False
            Me.grdTaules.Columns.Clear()
            ' Configurem el grid
            Me.grdTaules.Columns.Add("Id. Taula", "Id. Taula")
            Me.grdTaules.Columns.Add("Nombre de seients", "Nombre de seients")
            ' Posem les mides de les columnes
            Me.grdTaules.Columns("Id. Taula").Width = 100
            Me.grdTaules.Columns("Nombre de seients").Width = 389
            '
            Me.grdTaules.Columns("Id. Taula").DataPropertyName = "idTaula"
            Me.grdTaules.Columns("Nombre de seients").DataPropertyName = "numSeients"
            '
            Me.grdTaules.DataSource = connexio.LlistaTaules()
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub FormTaules_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.NetejarFormulari()
    End Sub

    Private Sub ModificarTaulaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ModificarTaulaToolStripMenuItem.Click
        Dim idTaula As Long
        idTaula = Me.grdTaules.Rows(Me.grdTaules.CurrentRow.Index).Cells("Id. Taula").Value
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            ' Carreguem les dades als textboxs
            Dim taula = connexio.ConsultarTaula(idTaula)
            Me.oTaula = New Taula(taula.idTaula, taula.numSeients)
            '
            Me.NmcSeientsTaula.Value = oTaula._numSeients
            ' Posem el botó a update
            Me.mode = 0
            Me.btnAlta.Text = "Actualitzar"
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub

    Private Sub EsborrarTaulaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EsborrarTaulaToolStripMenuItem.Click
        Dim idTaula As Long
        idTaula = Me.grdTaules.Rows(Me.grdTaules.CurrentRow.Index).Cells("Id. Taula").Value
        Dim connexio As ServeiClient = New ServeiGR.ServeiClient
        Try
            ' Carreguem les dades als textboxs
            Dim taula = connexio.ConsultarTaula(idTaula)
            Me.oTaula = New Taula(taula.idTaula, taula.numSeients)
            '
            If Not oTaula Is Nothing Then
                ' Mirem si es pot esborrar; si no es pot, no té sentit que demani si la vol esborrar:
                If Not oTaula.EsPotEsborrarTaula() Then
                    MsgBox("La taula no es pot esborrar perquè hi ha comandes que en depenen")
                    Exit Sub
                End If
                '
                Dim iResult As Integer
                iResult = MsgBox("S'eliminanarà una taula , estàs segur?", MsgBoxStyle.OkCancel)
                If iResult = 1 Then
                    If oTaula.EsborrarTaula() Then
                        MsgBox("Taula esborrada")
                    End If
                    Me.NetejarFormulari()
                    Me.OmplirGrid()
                End If
            Else
                MsgBox("Falta escollir taula")
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            connexio.Close()
        End Try
    End Sub
End Class