﻿Imports GRLlibreriaClasses

Public Class MenuGR
    ' Creem la conexiò
    Dim connexio As New GRDataClassesDataContext

    Public Function ConsultarMenu() As MenuNET
        Try
            Dim menuCAP = (From c In connexio.Menu _
                           Order By c.idMenu _
                           Descending Select New MenuNET(c.idMenu, c.numComensals, c.preu, c.iva, c.beguda, New List(Of PlatNET))).FirstOrDefault

            Dim llistat
            Dim oMenu As MenuNET = Nothing

            If Not menuCAP Is Nothing Then

                llistat = (From p In connexio.Plat _
                            Group Join pm In (From x In connexio.PlatMenu _
                                              Where x.idMenu.Equals(menuCAP.lIdMenu)) _
                                              On p.idPlat Equals pm.idPlat Into platMenu = Group _
                            From r In platMenu.DefaultIfEmpty() _
                            Group Join m In connexio.Menu On r.idMenu Equals m.idMenu Into menu = Group _
                            From s In menu.DefaultIfEmpty() _
                            Group Join secc In connexio.Seccio On p.idSeccio Equals secc.idSeccio Into Seccio = Group _
                            From t In Seccio.DefaultIfEmpty() _
                            Order By t.ordre _
                            Select New PlatNET(p.idPlat, _
                                                p.nomCat, _
                                                p.nomCas, _
                                                p.nomAng, _
                                                p.minPersones, _
                                                CType(p.preu, Double), _
                                                p.urlFoto, _
                                                p.idSeccio, _
                                                If(s.idMenu > 0, 1, 0), _
                                                t.nomCat)).ToList
                oMenu = New MenuNET(menuCAP.lIdMenu, menuCAP.lMinComensals, menuCAP.dPreu, menuCAP.bIVA, menuCAP.bBeguda, llistat)
            Else
                llistat = (From p In connexio.Plat _
                            Group Join pm In connexio.PlatMenu On p.idPlat Equals pm.idPlat Into platMenu = Group _
                            From r In platMenu.DefaultIfEmpty() _
                            Where r Is Nothing _
                            Group Join m In connexio.Menu On r.idMenu Equals m.idMenu Into menu = Group _
                            From s In menu.DefaultIfEmpty() _
                            Where s Is Nothing _
                            Group Join secc In connexio.Seccio On p.idSeccio Equals secc.idSeccio Into Seccio = Group _
                            From t In Seccio.DefaultIfEmpty() _
                            Where t IsNot Nothing _
                            Order By t.ordre _
                            Select New PlatNET(p.idPlat, _
                                                p.nomCat, _
                                                p.nomCas, _
                                                p.nomAng, _
                                                p.minPersones, _
                                                CType(p.preu, Double), _
                                                p.urlFoto, _
                                                p.idSeccio, _
                                                If(s.idMenu > 0, 1, 0), _
                                                t.nomCat)).ToList
                oMenu = New MenuNET(-1, 1, 0, 0, 0, llistat)
            End If

            Return oMenu

        Catch ex As Exception
            MsgBox(ex.Message)
            Return Nothing
        End Try

    End Function

    Public Function AfegirMenu(ByVal lMinComensals As Long, _
                   ByVal dPreu As Double, _
                   ByVal bIva As Boolean, _
                   ByVal bBeguda As Boolean, _
                   ByVal plats As List(Of PlatNET)) As Boolean
        AfegirMenu = False
        Try
            ' Pel menú
            Dim m As New Menu()
            m.numComensals = lMinComensals
            m.preu = dPreu
            m.iva = bIva
            m.beguda = bBeguda
            m.data = Date.Now
            connexio.Menu.InsertOnSubmit(m)
            connexio.SubmitChanges()

            ' Inserim a la taula platMenú
            For Each p In plats
                Dim pm As New PlatMenu
                pm.idMenu = m.idMenu
                pm.idPlat = p.idPlat
                connexio.PlatMenu.InsertOnSubmit(pm)
                pm = Nothing
            Next
            connexio.SubmitChanges()
            '
            AfegirMenu = True
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Function

    ' consulta amb SQL per carregar l'últim menú:

    'SELECT T0.Idplat, T3.nomCat, T0.nomCat, T2.idmenu,
    'CASE
    'WHEN isnull(T2.idmenu,'') = '' THEN 'No forma part del menú'
    'ELSE 'És menú'
    'END,
    'T2.data, T2.numComensals, T2.preu, T2.iva, T2.beguda
    'from plat T0
    'LEFT JOIN (SELECT * FROM platMenu where idMenu=20) T1 on t0.idplat = t1.idplat
    'LEFT JOIN menu T2 on T1.idmenu = T2.idmenu
    'LEFT JOIN seccio T3 ON T0.idseccio = T3.idSeccio

End Class
