﻿Imports GRLlibreriaClasses

Public Class OfertaGR
    ' Creem la connexió
    Dim connexio As New GRDataClassesDataContext

    Public Function AfegirOferta(ByVal sAssumpteCat As String, _
                  ByVal sAssumpteCas As String, _
                  ByVal sAssumpteAng As String, _
                  ByVal dDataOferta As Date, _
                  ByVal dDataCaducitat As Date, _
                  ByVal sContingutCat As String, _
                  ByVal sContingutCas As String, _
                  ByVal sContingutAng As String) As Boolean

        Try
            AfegirOferta = False
            Dim o As New Oferta
            o.data = dDataOferta
            o.dataCaducitat = dDataCaducitat
            o.assumpteCat = sAssumpteCat
            o.assumpteCas = sAssumpteCas
            o.assumpteAng = sAssumpteAng
            o.contingutCat = sContingutCat
            o.contingutCas = sContingutCas
            o.contingutAng = sContingutAng
            '
            connexio.Oferta.InsertOnSubmit(o)
            connexio.SubmitChanges()
            '
            AfegirOferta = True
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Function

    Public Function LlistarOfertes() As List(Of OfertaNET)
        Try
            Return (From c In connexio.Oferta _
                    Order By c.dataCaducitat Descending _
                    Select New OfertaNET(c.idOferta, c.data, c.dataCaducitat, c.assumpteCat)).ToList
        Catch ex As Exception
            MsgBox(ex.Message)
            Return New List(Of OfertaNET)
        End Try
    End Function

    Public Function ConsultarOferta(ByVal lIdOferta As Long) As OfertaNET
        Try
            Dim oferta = (From c In connexio.Oferta Where c.idOferta.Equals(lIdOferta) _
                        Select New OfertaNET(c.idOferta, c.data, c.dataCaducitat, c.assumpteCat, c.assumpteCas, c.assumpteAng, c.contingutCat, c.contingutCas, c.contingutAng))
            Return oferta.First

        Catch ex As Exception
            MsgBox(ex.Message)
            Return Nothing
        End Try
    End Function

    Public Function EsborrarOferta(ByVal lIdOferta As Long) As Boolean
        Try
            EsborrarOferta = False
            Dim oferta = From c In connexio.Oferta Where c.idOferta.Equals(lIdOferta) Select c
            connexio.Oferta.DeleteOnSubmit(oferta.First)
            connexio.SubmitChanges()
            EsborrarOferta = True
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Function

    Public Function EsPotEsborrarOferta(ByVal lIdOferta As Long) As Boolean
        Try
            EsPotEsborrarOferta = False
            ' Comprova si ha estat enviada a la taula Enviament. Si ja ha estat enviada, no la deixem esborrar
            Dim OfertaEnviada = (From c In connexio.Enviament Where c.idOferta.Equals(lIdOferta) Select c).Count
            If OfertaEnviada = 0 Then
                EsPotEsborrarOferta = True
            End If
        Catch ex As Exception

        End Try
    End Function

    Public Function ModificarOferta(ByVal lIdOferta As Long, _
                                ByVal sAssumpteCat As String, _
                              ByVal sAssumpteCas As String, _
                              ByVal sAssumpteAng As String, _
                              ByVal dDataOferta As Date, _
                              ByVal dDataCaducitat As Date, _
                              ByVal sContingutCat As String, _
                              ByVal sContingutCas As String, _
                              ByVal sContingutAng As String) As Boolean
        Try
            ModificarOferta = False
            ' Buscar l'oferta vella
            Dim antigaOferta = (From c In connexio.Oferta Where c.idOferta.Equals(lIdOferta) Select c).First
            ' Modificar les noves dades
            antigaOferta.assumpteCat = sAssumpteCat
            antigaOferta.assumpteCas = sAssumpteCas
            antigaOferta.assumpteAng = sAssumpteAng
            antigaOferta.data = dDataOferta
            antigaOferta.dataCaducitat = dDataCaducitat
            antigaOferta.contingutCat = sContingutCat
            antigaOferta.contingutCas = sContingutCas
            antigaOferta.contingutAng = sContingutAng
            ' 
            connexio.SubmitChanges()
            ModificarOferta = True
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Function

End Class
