﻿Imports GRLlibreriaClasses

Public Class PlatGR
    ' Creem la connexió
    Dim connexio As New GRDataClassesDataContext

    Public Function AfegirPlat(ByVal sNomCat As String, _
                              ByVal sNomCas As String, _
                              ByVal sNomAng As String, _
                              ByVal lMinPersones As Long, _
                              ByVal dPreu As Double, _
                              ByVal sUrlFoto As String, _
                              ByVal lIdSeccio As Long, _
                              Optional ByVal oFoto() As Byte = Nothing) As Boolean

        Try
            AfegirPlat = False
            Dim p As New Plat
            p.nomCat = sNomCat
            p.nomCas = sNomCas
            p.nomAng = sNomAng
            p.minPersones = lMinPersones
            p.preu = dPreu
            p.urlFoto = sUrlFoto
            p.idSeccio = lIdSeccio
            '
            If Not oFoto Is Nothing Then
                p.imatge = oFoto
            End If
            '
            connexio.Plat.InsertOnSubmit(p)
            connexio.SubmitChanges()
            '
            AfegirPlat = True

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Function

    Public Function LlistarPlats(ByVal idSeccio As Long) As List(Of PlatNET)
        Try
            Return (From c In connexio.Plat _
                    Where c.idSeccio.Equals(idSeccio) _
                    Order By c.nomCat _
                    Select New PlatNET(c.idPlat, c.nomCat)).ToList
        Catch ex As Exception
            MsgBox(ex.Message)
            Return New List(Of PlatNET)
        End Try
    End Function

    Public Function ConsultarPlat(ByVal idPlat As Long) As PlatNET
        Try
            Dim plat = (From c In connexio.Plat _
                        Where c.idPlat.Equals(idPlat) _
                        Select New PlatNET(c.idPlat, _
                                           c.nomCat, _
                                           c.nomCas, _
                                           c.nomAng, _
                                           c.minPersones, _
                                           c.preu, _
                                           c.urlFoto, _
                                           c.idSeccio))
            Return plat.First
        Catch ex As Exception
            MsgBox(ex.Message)
            Return Nothing
        End Try
    End Function

    Public Function EsborrarPlat(ByVal idPlat As Long) As Boolean
        Try
            EsborrarPlat = False
            '
            Dim plat = From c In connexio.Plat Where c.idPlat.Equals(idPlat) Select c
            connexio.Plat.DeleteOnSubmit(plat.First)
            connexio.SubmitChanges()
            EsborrarPlat = True
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Function

    Public Function EsPotEsborrarPlat(ByVal idPlat As Long) As Boolean
        EsPotEsborrarPlat = True

        Try
            ' Si hi ha el plat en una comanda, no es pot esborrar
            Dim platComanda = (From c In connexio.PlatComanda _
                    Where c.idPlat.Equals(idPlat) _
                    Select c).ToList
            '
            If platComanda.Count > 0 Then
                EsPotEsborrarPlat = False
            End If
            ' Si hi ha el plat al menú (cal tenir present l'històric), no es pot esborrar
            Dim platMenu = (From c In connexio.PlatMenu _
                    Where c.idPlat.Equals(idPlat) _
                    Select c).ToList
            '
            If platMenu.Count > 0 Then
                EsPotEsborrarPlat = False
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Function

    Public Function ModificarPlat(ByVal IdPlat As Long, _
                                    ByVal sNomCat As String, _
                                    ByVal sNomCas As String, _
                                    ByVal sNomAng As String, _
                                    ByVal lMinPersones As Long, _
                                    ByVal dPreu As Double, _
                                    ByVal sUrlFoto As String, _
                                    ByVal lIdSeccio As Long, _
                                    Optional ByVal oFoto() As Byte = Nothing) As Boolean
        Try
            ModificarPlat = False
            ' Buscar la secció vella
            Dim anticPlat = (From c In connexio.Plat Where c.idPlat.Equals(IdPlat) Select c).First
            ' Modificar les noves dades
            anticPlat.nomCat = sNomCat
            anticPlat.nomCas = sNomCas
            anticPlat.nomAng = sNomAng
            anticPlat.minPersones = lMinPersones
            anticPlat.preu = dPreu
            anticPlat.urlFoto = sUrlFoto
            anticPlat.idSeccio = lIdSeccio
            '
            If Not oFoto Is Nothing Then
                anticPlat.imatge = oFoto
            End If
            ' 
            connexio.SubmitChanges()
            '
            ModificarPlat = True
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Function

End Class
