﻿Imports GRLlibreriaClasses
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports GRNegoci

Partial Public Class Formulario_web111
    Inherits PaginaBasica

    ' Creem la connexió
    Dim connexio As New GRDataClassesDataContext

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Carreguem les dades
        If Not Page.IsPostBack Then
            Me.grdComandes.PageIndex = 0
        End If
        Me.OmplirComandes()
    End Sub

    Private Sub OmplirComandes()
        Try
            '
            ' SELECT T0.IdComanda, T0.data, T1.Nom + T1.Cognom as [Cambrer], T0.idTaula, T0.numComensals FROM Comanda T0
            ' INNER JOIN Persona T1 ON T0.IdCambrer = T1.IdPersona
            ' WHERE T0.idCambrer = 68
            Dim comandesCAP = (From comandes In connexio.Comanda _
                               Group Join p In connexio.Persona On comandes.idCambrer Equals p.idPersona Into pers = Group _
                               From persones In pers.DefaultIfEmpty() _
                                Where comandes.idCambrer.Equals(Session("usuari")) _
                                Order By comandes.data _
                                Descending Select _
                                comandes.idComanda, _
                                data = comandes.data.Value.Day & "/" & comandes.data.Value.Month & "/" & comandes.data.Value.Year, _
                                cambrer = persones.nom & " " & persones.cognom, _
                                comandes.idTaula, _
                                comandes.numComensals).ToArray
            ' Si hi ha comandes, les mostrem
            If comandesCAP.Count > 0 Then
                ' Tracatament del grid
                Me.grdComandes.Columns.Clear()
                Me.grdComandes.GridLines = GridLines.Horizontal
                ' Columna Comanda
                Dim bdfComanda As BoundField = New BoundField
                bdfComanda.ShowHeader = True
                bdfComanda.HeaderText = "Comanda"
                bdfComanda.DataField = "idComanda"
                Me.grdComandes.Columns.Add(bdfComanda)
                ' Columna Data
                Dim bdfData As BoundField = New BoundField
                bdfData.ShowHeader = True
                bdfData.HeaderText = "Data"
                bdfData.DataField = "data"
                Me.grdComandes.Columns.Add(bdfData)
                ' Columna Cambrer
                Dim bdfCambrer As BoundField = New BoundField
                bdfCambrer.ShowHeader = True
                bdfCambrer.HeaderText = "Cambrer"
                bdfCambrer.DataField = "cambrer"
                Me.grdComandes.Columns.Add(bdfCambrer)
                ' Columna Taula
                Dim bdfTaula As BoundField = New BoundField
                bdfTaula.ShowHeader = True
                bdfTaula.HeaderText = "Taula"
                bdfTaula.DataField = "idTaula"
                Me.grdComandes.Columns.Add(bdfTaula)
                ' Columna Número de comensals
                Dim bdfComansals As BoundField = New BoundField
                bdfComansals.ShowHeader = True
                bdfComansals.HeaderText = "Núm. Comensals"
                bdfComansals.DataField = "numComensals"
                Me.grdComandes.Columns.Add(bdfComansals)
                ' Omplim el grid
                Me.grdComandes.DataSource = comandesCAP
                Me.grdComandes.DataBind()
                Me.grdComandes.PageIndex = 0
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub grdComandes_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles grdComandes.PageIndexChanging
        Me.grdComandes.PageIndex = e.NewPageIndex
        Me.grdComandes.DataBind()
    End Sub

    Private Sub grdComandes_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdComandes.RowDataBound
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            e.Row.Attributes("onDblClick") = ("location.href='comanda.aspx?comanda=" & DataBinder.Eval(e.Row.DataItem, "idComanda") & "'")
        End If
    End Sub

    
End Class