﻿Imports GRLlibreriaClasses
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports GRNegoci

Partial Public Class index
    Inherits System.Web.UI.Page

    Dim connexio As New GRDataClassesDataContext

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            Me.OmplirComboTaules()
            Me.OmplirComboComensals()
            Me.OmplirGridPlats()
        End If
    End Sub

    Private Sub OmplirComboTaules()
        ' Seleccionem les taules i les posem al combobox
        Try
            Dim taules
            taules = (From s In connexio.Taula _
                      Order By s.numSeients _
                      Select s.idTaula, nomTaula = "Taula: " & s.idTaula & " - " & s.numSeients & " pers.").ToList
            Me.cmbTaules.DataValueField = "idTaula"
            Me.cmbTaules.DataTextField = "nomTaula"
            '
            Me.cmbTaules.DataSource = taules
            Me.cmbTaules.DataBind()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        '
    End Sub

    Private Sub OmplirComboComensals()
        ' 
        Try
            Dim i As Integer
            For i = 1 To 100
                ' Posem el valor al dropdownlist
                Me.cmbNumComensals.Items.Add(i.ToString)
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        ''
    End Sub

    Private Sub OmplirGridPlats()
        Try
            Dim plats
            plats = (From p In connexio.Plat _
                     Group Join secc In connexio.Seccio On p.idSeccio Equals secc.idSeccio Into Seccio = Group _
                     From t In Seccio.DefaultIfEmpty() _
                     Where t IsNot Nothing _
                     Order By t.ordre, CType(p.preu, Double), p.nomCat Select p.idPlat, plat = t.nomCat & ": " & p.nomCat, qtt = 0).ToList
            '
            ' Tracatament del grid
            'Me.grdPlats.Columns.Clear()
            'Me.grdPlats.GridLines = GridLines.Horizontal
            ' Columna idPlat
            'Dim bdfIdPlat As BoundField = New BoundField
            'bdfIdPlat.ShowHeader = False
            'bdfIdPlat.HeaderText = "id plat"
            'bdfIdPlat.DataField = "idPlat"
            'bdfIdPlat.Visible = False
            'Me.grdPlats.Columns.Add(bdfIdPlat)
            '' Columna nom del plat
            'Dim bdfNomPlat As BoundField = New BoundField
            'bdfNomPlat.ShowHeader = True
            'bdfNomPlat.HeaderText = "Nom plat"
            'bdfNomPlat.DataField = "plat"
            ''bdfNomPlat.ItemStyle.Width = 400
            'Me.grdPlats.Columns.Add(bdfNomPlat)
            '' Columna qtt
            'Dim qttPlat As TemplateField = New TemplateField
            ''qttPlat.ItemTemplate = New DropDownList()

            'Me.grdPlats.Columns.Add(qttPlat)
            Me.grdPlats.Columns.Item(0).ItemStyle.Width = 0
            Me.grdPlats.Columns.Item(1).ItemStyle.Width = 50
            Me.grdPlats.Columns.Item(2).ItemStyle.Width = 50

            '
            Me.grdPlats.DataSource = plats
            Me.grdPlats.DataBind()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        
    End Sub

    Private Sub grdPlats_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdPlats.RowDataBound
        Select Case e.Row.RowType
            Case DataControlRowType.DataRow
                Dim combo As DropDownList = CType(e.Row.FindControl("qtt"), DropDownList)
                If Not combo Is Nothing Then
                    Dim i As Integer
                    For i = 0 To 100
                        ' Posem el valor al dropdownlist
                        combo.Items.Add(i.ToString)
                    Next
                End If
        End Select
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button1.Click
        ' Plats
        Dim llistaPlatsComanda As New List(Of PlatComandaGR)
        Try

            For Each row As GridViewRow In Me.grdPlats.Rows
                Dim plat As String = Convert.ToInt32(Me.grdPlats.DataKeys(row.RowIndex).Values("idPlat"))
                Dim combo As DropDownList = CType(row.FindControl("qtt"), DropDownList)
                Dim valorCombo As String = combo.SelectedItem.Text
                If CType(valorCombo, Long) > 0 Then
                    Dim pc As New PlatComandaGR(-1, CType(plat, Long), CType(valorCombo, Long))
                    llistaPlatsComanda.Add(pc)
                End If
                'Dim ttt2 As TextBox = CType(row.FindControl("TextBox1"), TextBox)
                'MsgBox(ttt2.Text)
            Next
            ' Creem l'objecte comanda
            Dim oComanda As New ComandaGR
            ' Posem propietats
            '
            If llistaPlatsComanda.Count > 0 Then
                If oComanda.AfegirComanda(Me.cmbNumComensals.SelectedValue, Session("usuari"), Me.cmbTaules.SelectedValue, llistaPlatsComanda) Then
                    Me.Label3.Text = "Comanda entrada correctament"
                    ' Buidem comanda
                    oComanda = Nothing
                    ' Buidem els plats
                    llistaPlatsComanda.Clear()
                    Me.OmplirComboTaules()
                    Me.OmplirComboComensals()
                    Me.OmplirGridPlats()
                    '
                End If
            Else
                Me.Label3.Text = "Falta escollir plats"
                'llistaPlatsComanda.Clear()
            End If
            '
        Catch ex As Exception
            llistaPlatsComanda.Clear()
            Me.OmplirComboTaules()
            Me.OmplirComboComensals()
            Me.OmplirGridPlats()
            Me.Label3.Text = ex.Message
        End Try
    End Sub

End Class