﻿Imports GRLlibreriaClasses
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports GRNegoci

Partial Public Class Formulario_web19
    Inherits PaginaBasica
    ' Creem la connexió
    Dim connexio As New GRDataClassesDataContext
    Dim lSeccio As Long = -1

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Carreguem les dades
        If Not Page.IsPostBack Then
            Me.OmplirCombo()
            Me.grdPlats.PageIndex = 0
        End If
        Me.OmplirGrid(Me.lSeccio)
        '
    End Sub

    Private Sub OmplirCombo()
        ' Carreguem les seccions al combobox:
        Try
            Dim seccions
            Select Case Session("llengua")
                Case "ca-ES"
                    seccions = (From s In connexio.Seccio Order By s.ordre Select s.idSeccio, s.nomCat).ToList
                    Me.cmbSeccions.DataTextField = "nomCat"
                Case "es-ES"
                    seccions = (From s In connexio.Seccio Order By s.ordre Select s.idSeccio, s.nomCas).ToList
                    Me.cmbSeccions.DataTextField = "nomCas"
                Case "en-GB"
                    seccions = (From s In connexio.Seccio Order By s.ordre Select s.idSeccio, s.nomAng).ToList
                    Me.cmbSeccions.DataTextField = "nomAng"
                Case Else
                    seccions = (From s In connexio.Seccio Order By s.ordre Select s.idSeccio, s.nomCat).ToList
                    Me.cmbSeccions.DataTextField = "nomCat"
            End Select
            '
            Me.cmbSeccions.DataValueField = "idSeccio"
            Me.cmbSeccions.DataSource = seccions
            Me.cmbSeccions.DataBind()
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        ''
    End Sub

    Private Sub OmplirGrid(Optional ByVal lSeccio As Long = -1)
        Try
            Dim sCampPlat As String
            Dim plats
            ' noms dels camps del grid
            Dim sPlat As String = ""
            Dim sNumComensals As String = ""
            Dim sPreu As String = ""
            '
            If lSeccio <> -1 Or Me.NullTo0(Me.cmbSeccions.SelectedValue) > 0 Then
                Select Case Session("llengua")
                    Case "ca-ES"
                        plats = (From p In connexio.Plat _
                                 Where p.idSeccio = (If(lSeccio > 0, lSeccio, CInt(Me.cmbSeccions.SelectedValue))) _
                                 Order By CType(p.preu, Double), p.nomCat Select p.idPlat, p.nomCat, p.minPersones, preu = CType(p.preu, Double)).ToList
                        sCampPlat = "nomCat"
                        sPlat = "Plat"
                        sNumComensals = "Número de comensals"
                        sPreu = "Preu (€)"
                    Case "es-ES"
                        plats = (From p In connexio.Plat _
                                 Where p.idSeccio = (If(lSeccio > 0, lSeccio, CInt(Me.cmbSeccions.SelectedValue))) _
                                 Order By CType(p.preu, Double), p.nomCas Select p.idPlat, p.nomCas, p.minPersones, preu = CType(p.preu, Double)).ToList
                        sCampPlat = "nomCas"
                        sPlat = "Plato"
                        sNumComensals = "Número de comensales"
                        sPreu = "Precio (€)"
                    Case "en-GB"
                        plats = (From p In connexio.Plat _
                                 Where p.idSeccio = (If(lSeccio > 0, lSeccio, CInt(Me.cmbSeccions.SelectedValue))) _
                                 Order By CType(p.preu, Double), p.nomAng Select p.idPlat, p.nomAng, p.minPersones, preu = CType(p.preu, Double)).ToList
                        sCampPlat = "nomAng"
                        sPlat = "Dish"
                        sNumComensals = "Number of diners"
                        sPreu = "(€) Price"
                    Case Else
                        plats = (From p In connexio.Plat _
                                 Where p.idSeccio = (If(lSeccio > 0, lSeccio, CInt(Me.cmbSeccions.SelectedValue))) _
                                 Order By CType(p.preu, Double), p.nomCat Select p.idPlat, p.nomCat, p.minPersones, preu = CType(p.preu, Double)).ToList
                        sCampPlat = "nomCat"
                        sPlat = "Plat"
                        sNumComensals = "Número de comensals"
                        sPreu = "Preu (€)"
                End Select
                '
                ' Tracatament del grid
                Me.grdPlats.Columns.Clear()
                Me.grdPlats.GridLines = GridLines.Horizontal
                ' Columna idPlat
                Dim bdfIdPlat As BoundField = New BoundField
                bdfIdPlat.ShowHeader = False
                bdfIdPlat.HeaderText = "id plat"
                bdfIdPlat.DataField = "idPlat"
                bdfIdPlat.Visible = False
                Me.grdPlats.Columns.Add(bdfIdPlat)
                ' Columna tipus Hyperlink per l'anllaç del plat --> Millora si hi ha fotografia
                'Dim hlfLink As HyperLinkField = New HyperLinkField
                'hlfLink.ShowHeader = False
                'hlfLink.HeaderText = ""
                'hlfLink.DataTextField = sCampPlat
                'hlfLink.NavigateUrl = "#"
                'grdPlats.Columns.Add(hlfLink)
                ' Columna Nom del plat
                Dim bdfNomPlat As BoundField = New BoundField
                bdfNomPlat.ShowHeader = True
                bdfNomPlat.HeaderText = sPlat
                bdfNomPlat.DataField = sCampPlat
                bdfNomPlat.ItemStyle.Width = 400
                Me.grdPlats.Columns.Add(bdfNomPlat)
                ' Columna mínim de persones
                Dim bdfComanals As BoundField = New BoundField
                bdfComanals.ShowHeader = True
                bdfComanals.HeaderText = sNumComensals
                bdfComanals.DataField = "minPersones"
                Me.grdPlats.Columns.Add(bdfComanals)
                ' Columna preu
                Dim bdfPreu As BoundField = New BoundField
                bdfPreu.ShowHeader = True
                bdfPreu.HeaderText = sPreu
                bdfPreu.DataField = "preu"
                Me.grdPlats.Columns.Add(bdfPreu)
                '
                Me.grdPlats.DataSource = plats
                Me.grdPlats.DataBind()
                Me.grdPlats.PageIndex = 0
            End If
            '
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Protected Sub cmbSeccions_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbSeccions.SelectedIndexChanged
        Me.OmplirGrid(Me.lSeccio)
    End Sub

    Private Sub grdPlats_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles grdPlats.PageIndexChanging
        Me.grdPlats.PageIndex = e.NewPageIndex
        Me.grdPlats.DataBind()
    End Sub

    'Private Sub grdPlats_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles grdPlats.RowDataBound
    '    If (e.Row.RowType = DataControlRowType.DataRow) Then
    '        'e.Row.Attributes("onClick") = ("alert(" & DataBinder.Eval(e.Row.DataItem, "idPlat") & ")")
    '        e.Row.Attributes("onClick") = ("javascript:canvi()")
    '    End If
    'End Sub

    Private Function NullTo0(ByVal oObjecte As Object) As Long
        If oObjecte.ToString = "" Then
            Return 0
        Else
            Return (CType(oObjecte.ToString, Long))
        End If
    End Function


End Class
