﻿Imports System.Net
Imports System.Net.Mail
Imports System.Net.Mime
Imports GRLlibreriaClasses
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports GRNegoci

Partial Public Class Formulario_web14
    Inherits PaginaBasica
    Dim connexio As New GRDataClassesDataContext

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Protected Sub btnContacteEnviar_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnContacteEnviar.Click
        '
        If Me.txtContacteNom.Text = "" Or _
            Me.txtContacteCorreuE.Text = "" Or _
            Me.txtContacteConsulta.Text = "" Then
            Exit Sub
        End If
        '
        If Not Me.EsMail(Me.txtContacteCorreuE.Text) Then
            Exit Sub
        End If
        '
        Dim msg As MailMessage = New MailMessage
        ' Configuració del client SMTP
        Dim client As SmtpClient = New SmtpClient
        Dim Config = (From conf In connexio.Configuracio Select conf).FirstOrDefault
        '
        If Config Is Nothing Then
            ' Posar en un label que s'ha enviat correctament
            Me.lblResultat.Visible = False
            Me.lblResultatFail.Visible = True
            Exit Sub
        End If
        ' Destinatari
        msg.To.Add(Config.ToAdreca)
        ' Adreça del remitent i nom que apareixerà a la safata d'entrada
        msg.From = New MailAddress(Me.txtContacteCorreuE.Text, Me.txtContacteNom.Text & " " & Me.txtContacteCognom.Text, System.Text.Encoding.UTF8)
        ' Asumpte del correu
        msg.Subject = "Consulta a través de la web"
        msg.SubjectEncoding = System.Text.Encoding.UTF8
        ' Missatge en qüestió
        msg.Body = Me.txtContacteConsulta.Text.Replace(vbCrLf, "<br />")
        msg.Body = msg.Body & "<br>-------------------<br>"
        msg.Body = msg.Body & Me.txtContacteNom.Text & " " & Me.txtContacteCognom.Text & "<br>"
        msg.Body = msg.Body & Me.txtContacteTelefon.Text & "<br>"
        msg.Body = msg.Body & Me.txtContacteCorreuE.Text
        msg.BodyEncoding = System.Text.Encoding.UTF8
        ' Indica si el cos del missatge és HTML
        msg.IsBodyHtml = True
        '
        ' Credencials del compte
        client.Credentials = New NetworkCredential(Config.CredencialsNom, Config.CredencialsPwd)
        ' Port del client SMTP
        client.Port = Config.Port
        ' Adreça del client SMTP
        client.Host = Config.Server
        ' Tipus d'encriptació
        client.EnableSsl = False
        '
        Try
            ' Enviament del correu
            client.Send(msg)
            ' Posar en un label que s'ha enviat correctament
            Me.lblResultatFail.Visible = False
            Me.lblResultat.Visible = True
        Catch ex As System.Net.Mail.SmtpException
            MsgBox(ex.Message)
        Finally
            Me.NetejarFormulari()
        End Try

    End Sub

    Private Sub NetejarFormulari()
        Me.txtContacteNom.Text = ""
        Me.txtContacteCognom.Text = ""
        Me.txtContacteTelefon.Text = ""
        Me.txtContacteCorreuE.Text = ""
        Me.txtContacteConsulta.Text = ""
    End Sub

    Private Function EsMail(ByVal sMail As String) As Boolean
        ' retorna true o false   
        Return Regex.IsMatch(sMail, "^([\w-]+\.)*?[\w-]+@[\w-]+\.([\w-]+\.)*?[\w]+$")
    End Function

End Class

