﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.ServiceModel
Imports System.Data.Linq
Imports System.Data.Linq.Mapping
Imports System.Runtime.Serialization
Imports GRLlibreriaClasses
Imports GRNegoci

' Definim la Interface que exposa els nostres serveis quan s'esta executant
<ServiceContract()> _
Public Interface IServei

#Region "Mètodes Cambrer"
    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Cambrer
    ' -----------------------------------------------------------------------------------------------
    <OperationContract()> _
    Function AfegirCambrer(ByVal sNom As String, _
                  ByVal sCognom As String, _
                  ByVal sTelefon As String, _
                  ByVal sCorreuE As String, _
                  ByVal sUsuari As String, _
                  ByVal sContrasenya As String, _
                  ByVal bHabilitat As Boolean)as Boolean

    <OperationContract()> _
    Function ConsultarCambrer(ByVal idPersona As Long) As CambrerNET

    <OperationContract()> _
    Function EsborrarCambrer(ByVal idPersona As Long) As Boolean

    <OperationContract()> _
    Function ModificarCambrer(ByVal idPersona As Long, _
                  ByVal sNom As String, _
                  ByVal sCognom As String, _
                  ByVal sTelefon As String, _
                  ByVal sCorreuE As String, _
                  ByVal sUsuari As String, _
                  ByVal sContrasenya As String, _
                  ByVal bHabilitat As Boolean) As Boolean

    <OperationContract()> _
    Function UsuariRepetit(ByVal sUsuari As String) As Boolean

    <OperationContract()> _
    Function LlistaCambrers() As List(Of CambrerNET)

    <OperationContract()> _
    Function EsPotEsborrarCambrer(ByVal idPersona As Long) As Boolean

#End Region

#Region "Mètodes registrat"
    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Registrat
    ' -----------------------------------------------------------------------------------------------
#End Region

#Region "Mètodes Secció"
    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Secció
    ' -----------------------------------------------------------------------------------------------
    <OperationContract()> _
    Function AfegirSeccio(ByVal sNomCat As String, _
                      ByVal sNomCas As String, _
                      ByVal sNomAng As String, _
                      ByVal lOrdre As Long) As Boolean

    <OperationContract()> _
    Function LlistaSeccions(ByVal tipusLlista As String) As List(Of SeccioNET)

    <OperationContract()> _
    Function ConsultarSeccio(ByVal idSeccio As Long) As SeccioNET

    <OperationContract()> _
    Function EsborrarSeccio(ByVal idSeccio As Long) As Boolean

    <OperationContract()> _
    Function ModificarSeccio(ByVal idSeccio As Long, _
              ByVal sNomCat As String, _
              ByVal sNomCas As String, _
              ByVal sNomAng As String, _
              ByVal lOrdre As Long) As Boolean
#End Region

#Region "Mètodes Carta"
    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Carta
    ' -----------------------------------------------------------------------------------------------
    <OperationContract()> _
    Function AfegirPlat(ByVal sNomCat As String, _
                      ByVal sNomCas As String, _
                      ByVal sNomAng As String, _
                      ByVal lMinPersones As Long, _
                      ByVal dPreu As Double, _
                      ByVal sUrlFoto As String, _
                      ByVal idSeccio As Long, _
                      Optional ByVal oFoto() As Byte = Nothing) As Boolean

    <OperationContract()> _
    Function LlistarPlats(ByVal idSeccio As Long) As List(Of PlatNET)

    <OperationContract()> _
    Function ConsultarPlat(ByVal idPlat As Long) As PlatNET

    <OperationContract()> _
    Function EsborrarPlat(ByVal idPlat As Long) As Boolean

    <OperationContract()> _
    Function ModificarPlat(ByVal lIdPlat As Long, _
                      ByVal sNomCat As String, _
                      ByVal sNomCas As String, _
                      ByVal sNomAng As String, _
                      ByVal lMinPersones As Long, _
                      ByVal dPreu As Double, _
                      ByVal sUrlFoto As String, _
                      ByVal idSeccio As Long) As Boolean

    <OperationContract()> _
    Function EsPotEsborrarPlat(ByVal idPlat As Long) As Boolean

#End Region

#Region "Mètodes Taula"
    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Taula
    ' -----------------------------------------------------------------------------------------------
    <OperationContract()> _
    Function AfegirTaula(ByVal lNumSeients As Long) As Boolean

    <OperationContract()> _
    Function LlistaTaules() As List(Of TaulaNET)

    <OperationContract()> _
    Function ConsultarTaula(ByVal idTaula As Long) As TaulaNET

    <OperationContract()> _
    Function EsPotEsborrarTaula(ByVal idTaula As Long) As Boolean

    <OperationContract()> _
    Function EsborrarTaula(ByVal idTaula As Long) As Boolean

    <OperationContract()> _
    Function ModificarTaula(ByVal idTaula As Long, ByVal lNumSeients As Long) As Boolean

#End Region

#Region "Mètodes Menú"

    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Menú
    ' -----------------------------------------------------------------------------------------------

    <OperationContract()> _
    Function ConsultarMenu() As MenuNET

    <OperationContract()> _
    Function AfegirMenu(ByVal lMinComensals As Long, _
                   ByVal dPreu As Double, _
                   ByVal bIva As Boolean, _
                   ByVal bBeguda As Boolean, _
                   ByVal plats As List(Of PlatNET)) As Boolean
#End Region

#Region "Mètodes Oferta"
    ' -----------------------------------------------------------------------------------------------
    ' Mètodes Oferta
    ' -----------------------------------------------------------------------------------------------
    <OperationContract()> _
    Function AfegirOferta(ByVal sAssumpteCat As String, _
                      ByVal sAssumpteCas As String, _
                      ByVal sAssumpteAng As String, _
                      ByVal dDataOferta As Date, _
                      ByVal dDataCaducitat As Date, _
                      ByVal sContingutCat As String, _
                      ByVal sContingutCas As String, _
                      ByVal sContingutAng As String) As Boolean

    <OperationContract()> _
    Function LlistarOfertes() As List(Of OfertaNET)

    <OperationContract()> _
    Function ConsultarOferta(ByVal lIdOferta As Long) As OfertaNET

    <OperationContract()> _
    Function EsborrarOferta(ByVal lIdOferta As Long) As Boolean

    <OperationContract()> _
    Function ModificarOferta(ByVal lIdOferta As Long, _
                        ByVal sAssumpteCat As String, _
                      ByVal sAssumpteCas As String, _
                      ByVal sAssumpteAng As String, _
                      ByVal dDataOferta As Date, _
                      ByVal dDataCaducitat As Date, _
                      ByVal sContingutCat As String, _
                      ByVal sContingutCas As String, _
                      ByVal sContingutAng As String) As Boolean

    <OperationContract()> _
    Function LlistaRegistrats() As List(Of RegistratNET)

    <OperationContract()> _
    Sub InserirEnviament(ByVal dDataEnviament As Date, ByVal lIdOferta As Long, ByVal lIdPersona As Long)

    <OperationContract()> _
    Function EsPotEsborrarOferta(ByVal lIdOferta As Long) As Boolean
#End Region


End Interface
